#include "EditPanel.h"
#include <wx/event.h>
#include <math.h>
#include "MainWin.h"
#include "Point.h"
#include "Line.h"
#include "Circle.h"
#include "Ellipse.h"
#include "Hyperbole.h"
#include "Parabola.h"
#include "RightPanel.h"
#include <string>
#include <list>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <wx/string.h>
#include <wx/dc.h>

#define PI 3.141592654

#define INF 1.0/0.0
static char cross_cursor_bits[] = {
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255,   0,   0,   0,   0,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 127, 255, 255,
    255, 127, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255 };

//pokud je down_mask sama nula tak je kurzor zadny:)
static char cross_cursor_mask[] = {
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0, 128, 127, 255,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0, 128,   0,   0,
      0, 128,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0  };



EditPanel::EditPanel(wxWindow *parent,
            wxWindowID winid,
            const wxPoint& pos,
            const wxSize& size,
            long style,
            const wxString& name)
       : wxPanel(parent, winid, pos, size, style, name),
       newName(this)
{

    this->parent = parent;
    gridSize = 10;
    colorSelect = wxColor(255, 0, 0);
    color = wxColor(0, 0, 0);
    snap = false;
    snapEndPoints = false;
    snapIntersect = false;
    tool = tSELECT;
    firstPoint = false;
    selected = NULL;
    zoom = 1;
    offsetx = 100;   //souradnice pocatku
    offsety = 400;
    selectX = -1;
    selectY = -1;
    selectNow = false;
    mouseStart = Coord(INF, INF);
    startMove = Coord(INF, INF);
    old2Coord = Coord(INF, INF);

    newName = Name(this);
//    objList.push_back(new Elipse(this, Coord(-20, 0), Coord(40, 0), Coord(10, 20), wxS("a")));
//    rendoList.push_back(objList);
//    objList.push_back(new Hyperbole(this, Coord(-20, 0), Coord(40, 0), Coord(10, 20), wxS("a")));
//    rendoList.push_back(objList);
//    objList.push_back(new Parabola(this, Coord(-20, 0), Coord(40, 0), wxS("a")));
//    rendoList.push_back(objList);

//    objList.push_back(new Point(this, Coord(-20,  0), wxS("E")));
//    rendoList.push_back(objList);
//    objList.push_back(new Point(this, Coord( 40,  0), wxS("F")));
//    rendoList.push_back(objList);
//    objList.push_back(new Point(this, Coord( 10, 20), wxS("C")));
//    rendoList.push_back(objList);

    #ifdef __WXMSW__
    for (int i=0; i < 32*32/8; ++i)
    {
        cross_cursor_mask[i] = ~cross_cursor_mask[i];
        cross_cursor_bits[i] = ~cross_cursor_bits[i];
    }

    wxBitmap cross_cursor_bitmap(cross_cursor_bits, 32, 32);
    wxBitmap cross_cursor_mask_bitmap(cross_cursor_mask, 32, 32);

    cross_cursor_bitmap.SetMask(new wxMask(cross_cursor_mask_bitmap));
    wxImage cross_cursor_image = cross_cursor_bitmap.ConvertToImage();
    cross_cursor_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_X, 15);
    cross_cursor_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_Y, 15);
    wxCursor cross_cursor_cursor = wxCursor(cross_cursor_image);
    #else
    wxCursor cross_cursor_cursor = wxCursor(cross_cursor_bits, 32, 32,
      15, 15, cross_cursor_mask, wxWHITE, wxBLACK);
    #endif
    SetCursor(cross_cursor_cursor);

}

BEGIN_EVENT_TABLE(EditPanel, wxPanel)

    EVT_PAINT(EditPanel::paintEvent)

    EVT_ERASE_BACKGROUND(EditPanel::OnEraseBackground)

    EVT_SIZE(EditPanel::OnSize)

    EVT_LEFT_UP(EditPanel::OnMouseLeftClickUp)

    EVT_LEFT_DOWN(EditPanel::OnMouseLeftClickDown)

    EVT_MOTION(EditPanel::OnMouseMove)

    EVT_MOUSEWHEEL(EditPanel::OnMouseWheel)

    EVT_RIGHT_UP(EditPanel::OnMouseRightClickUp)

    EVT_RIGHT_DOWN(EditPanel::OnMouseRightClickDown)

END_EVENT_TABLE()

void EditPanel::OnEraseBackground(wxEraseEvent &evt)
{

}

void EditPanel::OnSize(wxSizeEvent& evt)
{
    Refresh();
}

//nevim presne, ale je potreba
void EditPanel::paintEvent(wxPaintEvent & evt)
{
    int w, h;
    GetSize(&w,&h); //Size of EditPanel

    wxBitmap bitmap(w,h);
    wxMemoryDC mem_dc(bitmap);

    Render(mem_dc);

    wxPaintDC dc(this);
    dc.Blit(0, 0, w, h, &mem_dc, 0, 0);
}

//co vse se ma vykreslovat
void EditPanel::Render(wxDC& dc)
{
    int w, h;
    GetSize(&w,&h);

    //vykresleni zakladniho obdelniku, kam se vykresluje:)
    bool paint = false;
    dc.SetBrush(wxColor( 255, 255, 255));
    dc.SetPen(wxPen(wxColor( 0, 0, 0),1));
    dc.DrawRectangle(wxCoord(0), wxCoord(0), wxCoord(w), wxCoord(h));

    if (((MainWin*)parent)->grid)
        PaintGrid(dc);

    if (((MainWin*)parent)->axis)
    {
        int widhtPanel, heightPanel;
        this->GetSize(&widhtPanel, &heightPanel);

        dc.SetPen(wxPen(wxColor(255,0,0),1));

        dc.DrawLine(wxCoord(0),          wxCoord(offsety)     ,
                    wxCoord(widhtPanel), wxCoord(offsety)    );
        dc.DrawLine(wxCoord(offsetx),    wxCoord(0)           ,
                    wxCoord(offsetx),    wxCoord(heightPanel));
    }

    ObjList::iterator i;

    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        if ((*i) == selected)
            (*i)->Paint(dc, colorSelect);
        else
        {
            ObjList::iterator j;
            if (!listSelected.empty())
            {
                for(j = listSelected.begin(); j != listSelected.end(); ++j)
                    if ((*i) == (*j))
                    {
                        (*i)->Paint(dc, colorSelect);
                        paint = true;
                    }
                    else
                        (*j)->Paint(dc, colorSelect);
                if (!paint)
                    (*i)->Paint(dc);
                paint = false;
            }
            else
                (*i)->Paint(dc);
        }
    }

    if ((snap || snapEndPoints || snapIntersect) && this->tool != tSELECT &&
        !((this->tool == tPERPENDICULAR && selected == NULL) ||
          (this->tool == tPARALLEL      && selected == NULL) ||
          (this->tool == tEXTEND)       && selected == NULL)    )
    {
        double tmpx = mouseCoord.ToScreenX(this);
        double tmpy = mouseCoord.ToScreenY(this);
        dc.SetPen(wxPen(wxColor(255,0,0),1));
        dc.DrawLine(wxCoord(tmpx-8), wxCoord(tmpy), wxCoord(tmpx-3), wxCoord(tmpy));
        dc.DrawLine(wxCoord(tmpx+3), wxCoord(tmpy), wxCoord(tmpx+9), wxCoord(tmpy));
        dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy-8), wxCoord(tmpx), wxCoord(tmpy-3));
        dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy+3), wxCoord(tmpx), wxCoord(tmpy+8));
        dc.SetBrush(*wxTRANSPARENT_BRUSH);
        dc.DrawCircle(wxCoord(tmpx), wxCoord(tmpy), 3);
    }
    if (firstPoint && this->tool == tLINE)
    {
        Line line(this, oldCoord, mouseCoord, wxS("a"));
        line.SetLabel(false);
        line.Paint(dc);
    }
    if (firstPoint && this->tool == tCIRCLE)
    {
        double radius = coord.DistTo(mouseCoord);
        Circle circle(this, oldCoord, radius, wxS("k"));
        circle.SetLabel(false);
        circle.Paint(dc);
    }
    if (firstPoint && this->tool == tCOMPASSES && old2Coord != Coord(INF, INF))
    {
        double radius = old2Coord.DistTo(oldCoord);
        Circle circle(this, mouseCoord, radius, wxS("k"));
        circle.SetLabel(false);
        circle.Paint(dc);
    }
    if (selectNow)
    {
        dc.SetBrush(*wxTRANSPARENT_BRUSH);
        dc.SetPen(wxPen(wxColor(250,0,0),1, wxLONG_DASH));
        double Ax = mouseStart.ToScreenX(this);
        double Ay = mouseStart.ToScreenY(this);
        double Bx = mouseDownCoord.ToScreenX(this);
        double By = mouseDownCoord.ToScreenY(this);
        dc.DrawRectangle(wxCoord(Ax), wxCoord(Ay),
                         wxCoord(Bx - Ax), wxCoord(By - Ay));
    }
    //vykresleni pocatku
    double tmpx = offsetx;
    double tmpy = offsety;
    dc.SetPen(wxPen(wxColor(255,0,0),1));
    dc.DrawLine(wxCoord(tmpx-8), wxCoord(tmpy), wxCoord(tmpx-3), wxCoord(tmpy));
    dc.DrawLine(wxCoord(tmpx+3), wxCoord(tmpy), wxCoord(tmpx+9), wxCoord(tmpy));
    dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy-8), wxCoord(tmpx), wxCoord(tmpy-3));
    dc.DrawLine(wxCoord(tmpx), wxCoord(tmpy+3), wxCoord(tmpx), wxCoord(tmpy+8));

}

//obecna fukce, pro vice pouziti pro prichytavani bodu po ose X
double EditPanel::SnapX(double p2x)
{

    if ((fmod(p2x,gridSize)) > (gridSize / 2))
        {
            p2x = p2x + (gridSize - (fmod(p2x,gridSize)));
        }
    else
        {
            p2x = p2x - (fmod(p2x,gridSize));
        }
    return p2x;
}

//obecna fukce, pro vice pouziti pro prichytavani bodu po ose Y
double EditPanel::SnapY(double p2y)
{
    if ((fmod(p2y,gridSize)) > (gridSize / 2))
        {
            p2y = p2y + (gridSize - (fmod(p2y,gridSize)));
        }
    else
        {
            p2y = p2y - (fmod(p2y,gridSize));
        }
    return p2y;
}

Coord EditPanel::SnapEndPoints(Coord coord)
{
    seznam2::iterator i;
    double dist = INF;
    Coord tmp = Coord(INF, INF);
    for(i = endPoints.begin(); i != endPoints.end(); ++i)
    {
        if (i->first.DistTo(coord) < dist && i->second->GetVisibility())
        {
            dist = i->first.DistTo(coord);
            tmp = i->first;
        }
    }
    return tmp;
}

Coord EditPanel::SnapIntersect(Coord coord)
{
    seznam3::iterator i;
    double dist = INF;
    Coord tmp = Coord(INF, INF);
    for(i = intersects.begin(); i != intersects.end(); ++i)
    {
        if (i->first.DistTo(coord) < dist && i->second.first->GetVisibility() &&
                                             i->second.second->GetVisibility())
        {
            dist = i->first.DistTo(coord);
            tmp = i->first;
        }
    }
    return tmp;
}

//vyber kruznice, neboli lezi bod na kruznici
void EditPanel::SelectCircle(double myX1, double myY1)
{
    double myX, myY;
    ObjList::iterator i;
    int sequence2 = 0;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oCIRCLE && selected != (*i)
            && (*i)->GetVisibility() && (*i)->GetChange())
        {
            for (int ii=0; ii<9; ii++)
            {
                myX = myX1 + (ii%3) - 1;
                myY = myY1 + (ii/3) - 1;

                int a1 = (*i)->GetPos().x;
                int a2 = (*i)->GetPos().y;
                Circle k = *(Circle*)(*i);
                if (fabs((myX - a1)*(myX - a1) + (myY - a2)*(myY - a2) - (k.radius)*(k.radius)) < (k.radius))
                {
                    listSelected.push_back(*i);
                    sequence.push_back(sequence2);
                    ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                    //selected = (*i);
                    //((MainWin*)parent)->rightPanel->list->SetSelection(sequence);
                    return;
                }
            }
        }
    }
}

//prusecik dvou kruznic / vraci list pruseciku (0, 1, 2)
vector<Coord> EditPanel::IntersectionCircles(Coord S, double r1, Coord U, double r2)
{
    vector<Coord> tmp;
    double k = (r1*r1 - r2*r2 - S.x*S.x + U.x*U.x - S.y*S.y + U.y*U.y) / (2*U.x - 2*S.x);
    double k1 = (U.y - S.y) / (U.x - S.x);

    double a = k1*k1 + 1;
    double b = -2*k*k1 + 2*S.x*k1 - 2*S.y;
    double c = k*k - 2*S.x*k + S.x*S.x +S.y*S.y - r1*r1;

    double D = b*b - 4*a*c;

    if (D == 0)
    {
        double y1 = ((-1)*b) / (2*a);
        double x1 = k - y1*k1;
        tmp.push_back(Coord(x1, y1));
    }
    if (D > 0)
    {
        double y1 = (-b + sqrt(D))/(2*a);
        double x1 = k - y1*k1;
        double y2 = (-b - sqrt(D))/(2*a);
        double x2 = k - y2*k1;
        tmp.push_back(Coord(x1, y1));
        tmp.push_back(Coord(x2, y2));
    }
    return tmp;
}

//prusecik primky a kruznice / vraci list pruseciku (0, 1, 2)
vector<Coord> EditPanel::IntersectionCircle(Coord A, Coord B, Coord S, double r)
{
    vector<Coord> tmp;
    double ux = B.x - A.x;
    double uy = B.y - A.y;

    double a = ux*ux + uy*uy;
    double b = (A.x*ux + A.y*uy - S.x*ux - S.y*uy)*2;
    double c = A.x*A.x + S.x*S.x + A.y*A.y + S.y*S.y -2*A.x*S.x - 2*A.y*S.y- r*r;

    double D = b*b - 4*a*c;
    if (D > 0)
    {
        double t1 = (-b + sqrt(D)) / (2*a);
        double t2 = (-b - sqrt(D)) / (2*a);
        if ((t1 >= 0 && t1 <= 1))
        {
            //selected2.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t1, A.y + uy*t1), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t1, A.y + uy*t1));
        }
        if ((t2 >= 0 && t2 <= 1 ))
        {
            //selected2.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t2, A.y + uy*t2), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t2, A.y + uy*t2));
        }
    }
    if (D == 0)
    {
        double t = (-b) / (2*a);
        if ((t >= 0 && t <= 1))
        {
            //selected2.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t, A.y + uy*t), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t, A.y + uy*t));
        }
    }
    return tmp;
}

vector<Coord> EditPanel::IntersectionElipse(Coord A, Coord B, Coord S, double a, double b, double alfa)
{
    vector<Coord> tmp;
    double ux = B.x - A.x;
    double uy = B.y - A.y;

    Coord C(A.x - S.x, A.y - S.y);

    double c = cos(-alfa);
    double s = sin(-alfa);
    Coord k(c*ux - s*uy, s*ux + c*uy);

    double AA = k.x*k.x*b*b + k.y*k.y*a*a;
    double BB = 2*((C.x*c-C.y*s)*k.x*b*b + (C.y*c+C.x*s)*k.y*a*a);
    double CC = (C.x*c-C.y*s)*(C.x*c-C.y*s)*b*b + (C.y*c+C.x*s)*(C.y*c+C.x*s)*a*a - a*a*b*b;

    double D = BB*BB - 4*AA*CC;
    if (D > 0)
    {
        double t1 = (-BB + sqrt(D)) / (2*AA);
        double t2 = (-BB - sqrt(D)) / (2*AA);
        if ((t1 >= 0 && t1 <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t1, A.y + uy*t1), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t1, A.y + uy*t1));
        }
        if ((t2 >= 0 && t2 <= 1 ))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t2, A.y + uy*t2), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t2, A.y + uy*t2));
        }
    }
    if (D == 0)
    {
        double t = (-BB) / (2*AA);
        if ((t >= 0 && t <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t, A.y + uy*t), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t, A.y + uy*t));
        }
    }
    return tmp;
}


vector<Coord> EditPanel::IntersectionHyperbole(Coord A, Coord B, Coord S, double a, double b, double alfa)
{
    vector<Coord> tmp;
    double ux = B.x - A.x;
    double uy = B.y - A.y;

    Coord C(A.x - S.x, A.y - S.y);

    double c = cos(-alfa);
    double s = sin(-alfa);
    Coord k(c*ux - s*uy, s*ux + c*uy);

    double AA = k.x*k.x*b*b - k.y*k.y*a*a;
    double BB = 2*((C.x*c-C.y*s)*k.x*b*b - (C.y*c+C.x*s)*k.y*a*a);
    double CC = (C.x*c-C.y*s)*(C.x*c-C.y*s)*b*b - (C.y*c+C.x*s)*(C.y*c+C.x*s)*a*a - a*a*b*b;

    double D = BB*BB - 4*AA*CC;
    if (D > 0)
    {
        double t1 = (-BB + sqrt(D)) / (2*AA);
        double t2 = (-BB - sqrt(D)) / (2*AA);
        if ((t1 >= 0 && t1 <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t1, A.y + uy*t1), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t1, A.y + uy*t1));
        }
        if ((t2 >= 0 && t2 <= 1 ))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t2, A.y + uy*t2), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t2, A.y + uy*t2));
        }
    }
    if (D == 0)
    {
        double t = (-BB) / (2*AA);
        if ((t >= 0 && t <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t, A.y + uy*t), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t, A.y + uy*t));
        }
    }
    return tmp;
}

vector<Coord> EditPanel::IntersectionParabola(Coord A, Coord B, Coord S, double p, double alfa)
{
    vector<Coord> tmp;
    double ux = B.x - A.x;
    double uy = B.y - A.y;

    Coord C(A.x - S.x, A.y - S.y);
    double c = cos(2*PI-alfa);
    double s = sin(2*PI-alfa);
    Coord k(c*ux - s*uy, s*ux + c*uy);

    double AA = k.y*k.y;
    double BB = 2*((C.y*c+C.x*s)*k.y - k.x*p);
    double CC = (C.y*c+C.x*s)*(C.y*c+C.x*s) - (C.x*c-C.y*s)*2*p;

    double D = BB*BB - 4*AA*CC;
    if (D > 0)
    {
        double t1 = (-BB + sqrt(D)) / (2*AA);
        double t2 = (-BB - sqrt(D)) / (2*AA);
        if ((t1 >= 0 && t1 <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t1, A.y + uy*t1), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t1, A.y + uy*t1));
        }
        if ((t2 >= 0 && t2 <= 1 ))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t2, A.y + uy*t2), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t2, A.y + uy*t2));
        }
    }
    if (D == 0)
    {
        double t = (-BB) / (2*AA);
        if ((t >= 0 && t <= 1))
        {
            //listSelected.push_back(new Line(this, Coord(0.0, 0.0), Coord(A.x + ux*t, A.y + uy*t), wxS("a")));
            tmp.push_back(Coord(A.x + ux*t, A.y + uy*t));
        }
    }
    return tmp;
}

//vyber kruznice(vsechny) lezici v obdelniku
void EditPanel::SelectEllipses(Coord click, Coord click2)
{
    double myX, myY;
    ObjList::iterator i;
    int ii = 0;
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oELLIPSE  && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            double x, xx, y, yy;
            Coord pos = (*i)->GetPos();
            double a = (*i)->GetA();
            double b = (*i)->GetB();
            x = min(click.x, click2.x);
            xx = max(click.x, click2.x);
            y = min(click.y, click2.y);
            yy = max(click.y, click2.y);
            if ((x <= (pos.x - b) && xx >= (pos.x - b) && y <= pos.y && yy >= pos.y)||
                (x <= (pos.x + b) && xx >= (pos.x + b) && y <= (pos.y - b) && yy >= (pos.y - b))||
                (x <= pos.x && xx >= pos.x && y <= (pos.y - b) && yy >= (pos.y - b))||
                (x <= pos.x && xx >= pos.x && y <= (pos.y + b) && yy >= (pos.y + b)))
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionElipse(Coord(x, y), Coord(x, yy),
                                    (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                    ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionElipse(Coord(xx, yy), Coord(x, yy),
                                    (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                    ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionElipse(Coord(xx, yy), Coord(xx, y),
                                    (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                    ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionElipse(Coord(xx, y), Coord(x, y),
                                    (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                    ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }

        }
        ++ii;
    }
}

void EditPanel::SelectHyperboles(Coord click, Coord click2)
{
    double myX, myY;
    ObjList::iterator i;
    int ii = 0;
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oHYPERBOLE && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            double x, xx, y, yy;
            Coord pos = (*i)->GetPos();
            double a = (*i)->GetA();
            double b = (*i)->GetB();
            x = min(click.x, click2.x);
            xx = max(click.x, click2.x);
            y = min(click.y, click2.y);
            yy = max(click.y, click2.y);
            if (!IntersectionHyperbole(Coord(x, y), Coord(x, yy),
                                       (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                       ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionHyperbole(Coord(xx, yy), Coord(x, yy),
                                       (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                       ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionHyperbole(Coord(xx, yy), Coord(xx, y),
                                       (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                       ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionHyperbole(Coord(xx, y), Coord(x, y),
                                       (*i)->GetPos(), (*i)->GetA(), (*i)->GetB(), (*i)->GetAlfa()
                                       ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }

        }
        ++ii;
    }
}

void EditPanel::SelectParabolas(Coord click, Coord click2)
{
    double myX, myY;
    ObjList::iterator i;
    int ii = 0;
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oPARABOLA && (*i)->GetVisibility() && (*i)->GetChange())
        {
            double x, xx, y, yy;
            x = min(click.x, click2.x);
            xx = max(click.x, click2.x);
            y = min(click.y, click2.y);
            yy = max(click.y, click2.y);
            if (!IntersectionParabola(Coord(x, y), Coord(x, yy),
                                      (*i)->GetPos(), (*i)->GetP(), (*i)->GetAlfa()
                                      ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionParabola(Coord(xx, yy), Coord(x, yy),
                                      (*i)->GetPos(), (*i)->GetP(), (*i)->GetAlfa()
                                      ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionParabola(Coord(xx, yy), Coord(xx, y),
                                      (*i)->GetPos(), (*i)->GetP(), (*i)->GetAlfa()
                                      ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionParabola(Coord(xx, y), Coord(x, y),
                                      (*i)->GetPos(), (*i)->GetP(), (*i)->GetAlfa()
                                      ).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }

        }
        ++ii;
    }
}

void EditPanel::SelectCircles(Coord click, Coord click2)
{
    double myX, myY;
    ObjList::iterator i;
    int ii = 0;
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oCIRCLE  && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            double x, xx, y, yy;
            Coord pos = (*i)->GetPos();
            double r = (*i)->GetRadius();
            x = min(click.x, click2.x);
            xx = max(click.x, click2.x);
            y = min(click.y, click2.y);
            yy = max(click.y, click2.y);
            if ((x <= (pos.x - r) && xx >= (pos.x - r) && y <= pos.y && yy >= pos.y)||
                (x <= (pos.x + r) && xx >= (pos.x + r) && y <= (pos.y - r) && yy >= (pos.y - r))||
                (x <= pos.x && xx >= pos.x && y <= (pos.y - r) && yy >= (pos.y - r))||
                (x <= pos.x && xx >= pos.x && y <= (pos.y + r) && yy >= (pos.y + r)))
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionCircle(Coord(x, y), Coord(x, yy), (*i)->GetPos(), (*i)->GetRadius()).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionCircle(Coord(xx, yy), Coord(x, yy), (*i)->GetPos(), (*i)->GetRadius()).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionCircle(Coord(xx, yy), Coord(xx, y), (*i)->GetPos(), (*i)->GetRadius()).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
            if (!IntersectionCircle(Coord(xx, y), Coord(x, y), (*i)->GetPos(), (*i)->GetRadius()).empty())
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }

        }
        ++ii;
    }
}

//SelectHyperboles(mouseStart, coord);
//SelectParabolas(mouseStart, coord);

//vyber primky, tj lezi bod na primce
void EditPanel::SelectLine(double myX1, double myY1, int typ)
{
    double myX, myY;
    ObjList::iterator i;
    int sequence2 = 0;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oLINE && selected != (*i) && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            for (int ii=0; ii<9; ii++)
            {
                myX = myX1 + (ii%3) - 1;
                myY = myY1 + (ii/3) - 1;

                double a1 = (*i)->GetPos().x;
                double a2 = (*i)->GetPos().y;
                double b1 = (*i)->GetPos2().x;
                double b2 = (*i)->GetPos2().y;

                if (fabs( (a2 - b2)*myX + (b1 - a1)*myY - a2*b1 + a1*b2 ) < sqrt((a2-b2)*(a2-b2) + (b1-a1)*(b1-a1)))
                {
                    if (fabs(a1 - b1) < 1 || fabs(a2 - b2) < 1)
                        if (fabs(a1 - myX) < 1  || fabs(a2 - myY) < 1)
                        {
                            if (typ == 0)
                                selected = (*i);
                            else
                            {
                                listSelected.push_back(*i);
                                sequence.push_back(sequence2);
                                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                            }
                            //((MainWin*)parent)->rightPanel->list->SetSelection(sequence);
                            return;
                        }
                    if (a1 <= b1 && a2 <= b2)
                        if (myX >= a1 && myX <= b1 && myY >=a2 && myY <= b2)
                        {
                            if (typ == 0)
                                selected = (*i);
                            else
                            {
                                listSelected.push_back(*i);
                                sequence.push_back(sequence2);
                                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                            }
                            //((MainWin*)parent)->rightPanel->list->SetSelection(sequence);
                            return;
                        }
                    if (a1 <= b1 && a2 >= b2)
                        if (myX >= a1 && myX <= b1 && myY >=b2 && myY <= a2)
                        {
                            if (typ == 0)
                                selected = (*i);
                            else
                            {
                                listSelected.push_back(*i);
                                sequence.push_back(sequence2);
                                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                            }
                            return;
                        }
                    if (a1 >= b1 && a2 >= b2)
                        if (myX >= b1 && myX <= a1 && myY >=b2 && myY <= a2)
                        {
                            if (typ == 0)
                                selected = (*i);
                            else
                            {
                                listSelected.push_back(*i);
                                sequence.push_back(sequence2);
                                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                            }
                            return;
                        }
                    if (a1 >= b1 && a2 <= b2)
                        if (myX >= b1 && myX <= a1 && myY >=a2 && myY <= b2)
                        {
                            if (typ == 0)
                                selected = (*i);
                            else
                            {
                                listSelected.push_back(*i);
                                sequence.push_back(sequence2);
                                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                            }
                            return;
                        }
                }
            }
        }
    }
}

//prusecik primek / vraci prusecik
Coord EditPanel::Intersection(Coord line1A, Coord line2A, Coord line1B, Coord line2B)
{
    double ux = line2A.x - line1A.x;
    double uy = line2A.y - line1A.y;
    double vx = line2B.x - line1B.x;
    double vy = line2B.y - line1B.y;

    if (ux == vx && uy == vy)
        return Coord(0, INF);
    if (ux/vx == uy/vy)
        return Coord(INF, INF);
    else
    {
        double s = (line1A.x*uy - line1A.y*ux - line1B.x*uy + line1B.y*ux)/(vx*uy - vy*ux);
        double t = (line1B.x*vy - line1B.y*vx - line1A.x*vy + line1A.y*vx)/(ux*vy - uy*vx);
        if ((t >= 0 && t <= 1 && s >= 0 && s <= 1))
        {
            return Coord(line1A.x + t*ux, line1A.y + t*uy);
        }

        else
            return Coord(INF, INF);
    }
}

//vyber primek(vsech) v danem obdelniku
void EditPanel::SelectLines(Coord click, Coord click2)
{
    ObjList::iterator i;
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oLINE && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            double x, xx, y, yy;
            Coord pos = (*i)->GetPos();
            Coord pos2 = (*i)->GetPos2();
            {
                x = min(click.x, click2.x);
                xx = max(click.x, click2.x);
                y = min(click.y, click2.y);
                yy = max(click.y, click2.y);
                if ((x <= pos.x && xx >= pos.x && y <= pos.y && yy >= pos.y) ||
                    (x <= pos2.x && xx >= pos2.x && y <= pos2.y && yy >= pos2.y))
                {
                    listSelected.push_back(*i);
                    sequence.push_back(sequence2);
                    ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                }

            }

            Coord tmp1 = Intersection(Coord(x, y), Coord(x, yy),
                                      (*i)->GetPos(), (*i)->GetPos2());

            Coord tmp2 = Intersection(Coord(xx, yy), Coord(x, yy),
                                      (*i)->GetPos(), (*i)->GetPos2());

            Coord tmp3 = Intersection(Coord(xx, yy), Coord(xx, y),
                                      (*i)->GetPos(), (*i)->GetPos2());

            Coord tmp4 = Intersection(Coord(xx, y), Coord(x, y),
                                      (*i)->GetPos(), (*i)->GetPos2());

            int num = 0;
            if (tmp1.x != INF && tmp1.y != INF)
                num++;
            if (tmp2.x != INF && tmp2.y != INF)
                num++;
            if (tmp3.x != INF && tmp3.y != INF)
                num++;
            if (tmp4.x != INF && tmp4.y != INF)
                num++;
            if (  (tmp1.x == 0 && tmp1.y == INF) || (tmp2.x == 0 && tmp2.y == INF)
                ||(tmp3.x == 0 && tmp3.y == INF) || (tmp4.x == 0 && tmp4.y == INF))
                num++;

            if (num > 0)
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                num = 0;
            }
        }
    }
}

//vyber bodu
void EditPanel::SelectPoint(double myX1, double myY1)
{
    double myX, myY;
    ObjList::iterator i;
    int sequence2 = 0;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oPOINT && selected != (*i) && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            for (int ii=0; ii<9; ii++)
            {
               myX = myX1 + (ii%3) - 1;
               myY = myY1 + (ii/3) - 1;

                if ( (*i)->GetType() == oPOINT && selected != (*i)
                        && ((*i)->GetPos().x - myX > -1.0) && ((*i)->GetPos().x - myX < 1.0)
                        && ((*i)->GetPos().y - myY > -1.0) && ((*i)->GetPos().y - myY < 1.0))
                {
                    listSelected.push_back(*i);
                    sequence.push_back(sequence2);
                    ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
                    //selected = (*i);
                    //((MainWin*)parent)->rightPanel->list->SetSelection(sequence);
                    return;
                }

            }
        }
    }
}

//vyber bodu v obdelniku
void EditPanel::SelectPoints(Coord click, Coord click2)
{
    Coord pos;
    double x, xx, y, yy;
    ObjList::iterator i;
    x = min(click.x, click2.x);
    xx = max(click.x, click2.x);
    y = min(click.y, click2.y);
    yy = max(click.y, click2.y);
    int sequence2 = -1;
    for(i=objList.begin(); i!=objList.end(); ++i)
    {
        ++sequence2;
        if ((*i)->GetType() == oPOINT && (*i)->GetVisibility())// && (*i)->GetChange())
        {
            pos = (*i)->GetPos();
            if (x <= pos.x && xx >= pos.x && y <= pos.y && yy >= pos.y)
            {
                listSelected.push_back(*i);
                sequence.push_back(sequence2);
                ((MainWin*)parent)->rightPanel->list->SetSelection(sequence2);
            }
        }
    }
}

void EditPanel::FindIntersectionLine(Coord pos, Coord pos2, GeomObj* line)
{
    ObjList::iterator i;
    for(i=objList.begin(); i!=objList.end() && (*i) != line; ++i)
    {
        if ((*i)->GetType() == oLINE)
        {
            Coord tmp2 = Intersection(pos, pos2, (*i)->GetPos(), (*i)->GetPos2());
            if (!(tmp2 == Coord(INF, INF)) && !(tmp2 == Coord(0, INF)))
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(line, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> >(tmp2, pom));
            }
        }
        if ((*i)->GetType() == oCIRCLE)
        {
            vector<Coord> tmp2 = IntersectionCircle(pos, pos2, (*i)->GetPos(), (*i)->GetRadius());
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(line, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> >(tmp2[ii], pom));
            }
        }
        if ((*i)->GetType() == oELLIPSE)
        {
            vector<Coord> tmp2 = IntersectionElipse(pos,
                                                     pos2,
                                                     (*i)->GetPos(),
                                                     (*i)->GetA(),
                                                     (*i)->GetB(),
                                                     (*i)->GetAlfa());
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(line, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> >(tmp2[ii], pom));
            }
        }
        if ((*i)->GetType() == oHYPERBOLE)
        {
            vector<Coord> tmp2 = IntersectionHyperbole(pos,
                                                       pos2,
                                                       (*i)->GetPos(),
                                                       (*i)->GetA(),
                                                       (*i)->GetB(),
                                                       (*i)->GetAlfa());
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(line, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> >(tmp2[ii], pom));
            }
        }
        if ((*i)->GetType() == oPARABOLA)
        {
            vector<Coord> tmp2 = IntersectionParabola(pos,
                                                      pos2,
                                                      (*i)->GetPos(),
                                                      (*i)->GetP(),
                                                      (*i)->GetAlfa());
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(line, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> >(tmp2[ii], pom));
            }
        }
    }
}

void EditPanel::FindIntersectionCircle(Coord center, double radius, GeomObj* circle)
{
    ObjList::iterator i;
    for(i=objList.begin(); i!=objList.end() && (*i) != circle; ++i)
    {
        if ((*i)->GetType() == oLINE)
        {
            vector<Coord> tmp2 = IntersectionCircle((*i)->GetPos(), (*i)->GetPos2(), center, radius);
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(circle, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
            }
        }
        if ((*i)->GetType() == oCIRCLE)
        {
            vector<Coord> tmp2 = IntersectionCircles(center, radius, (*i)->GetPos(), (*i)->GetRadius());
            int ii;
            for(ii = 0; ii < tmp2.size(); ++ii)
            {
                pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(circle, (*i));
                intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
            }
        }
    }
}

//urci jaky objekt se ma vykreslovat a jak se ma prichytavat
void EditPanel::OnMouseLeftClickUp(wxMouseEvent& evt)
{
    wxString tmp2 = ((MainWin*)parent)->nameFile + wxS("* : Editor zaměřený na kuželosečky");
    ((MainWin*)parent)->SetTitle(tmp2);

    Coord lastCoord = coord;
    coord = Coord(this, evt.GetX(), evt.GetY());
    if (!((this->tool == tSELECT) ||
          (this->tool == tPERPENDICULAR && selected == NULL) ||
          (this->tool == tPARALLEL && selected == NULL) ||
          (this->tool == tEXTEND && selected == NULL) ))//||
//          (this->tool == tELLIPSE && selected == NULL) ||
//          (this->tool == tHYPERBOLE && selected == NULL) ||
//          (this->tool == tPARABOLA && selected == NULL)))
    {
        //snap k mrizce
        if (snap)// || this->tool == tSELECT)
        {
            coord.x = SnapX(coord.x);
            coord.y = SnapY(coord.y);
        }

        if (snapEndPoints)
        {
            coord = SnapEndPoints(coord);
        }

        if (snapIntersect)
        {
            coord = SnapIntersect(coord);
        }
    }
    if (this->tool == tPOINT)
    {
        wxString tmpName = newName.GetNamePoint();
        GeomObj *tmp = new Point(this, coord, tmpName);
        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

//        ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") + tmpName +
//                                                wxS(" je bod"));
        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        endPoints.push_back(pair<Coord, GeomObj*>(coord, tmp));
    }

    if (this->tool == tLINE && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        //((MainWin*)parent)->SetStatusText(wxS("Nástroj Přímka"), 0);
        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro druhý krajní bod"), 1);
    }

    else if (this->tool == tLINE && firstPoint)
    {
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Line(this, coord, oldCoord, tmpName);
        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

//        ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") +
//                                                wxS(" přímka ") + tmpName);
        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        firstPoint = false;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro první krajní bod"), 1);
        endPoints.push_back(pair<Coord, GeomObj*>(oldCoord, tmp));
        endPoints.push_back(pair<Coord, GeomObj*>(coord, tmp));
        FindIntersectionLine(coord, oldCoord, tmp);
    }

    if (this->tool == tCIRCLE && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro bod na kružnici"), 1);
    }

    else if (this->tool == tCIRCLE && firstPoint)
    {
        double radius = coord.DistTo(oldCoord);
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Circle(this, oldCoord, radius, tmpName);

        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        firstPoint = false;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro střed"), 1);
        FindIntersectionCircle(oldCoord, radius, tmp);
    }

    if (this->tool == tCOMPASSES && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro druhý bod, zadávající poloměr"), 1);
    }
    else if (this->tool == tCOMPASSES && firstPoint &&  old2Coord == Coord(INF, INF))
    {
        old2Coord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro střed"), 1);
    }
    else if (this->tool == tCOMPASSES && firstPoint &&  old2Coord != Coord(INF, INF))
    {
        double radius = old2Coord.DistTo(oldCoord);
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Circle(this, coord, radius, tmpName);

        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        firstPoint = false;
        old2Coord = Coord(INF, INF);
        oldCoord = Coord(INF, INF);

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu pro první bod, zadávající poloměr"), 1);
        FindIntersectionCircle(coord, radius, tmp);
    }

    if (this->tool == tELLIPSE && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - druhé ohnisko"), 1);
    }
    else if (this->tool == tELLIPSE && firstPoint && old2Coord == Coord(INF, INF))
    {
        old2Coord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - vedlejší vrchol"), 1);
    }
    else if (this->tool == tELLIPSE && firstPoint && old2Coord != Coord(INF, INF))
    {
        Coord C = coord;
        Coord E = oldCoord;
        Coord F = old2Coord;
        double t = ((C.x - E.x)*(F.x - E.x) + (F.y - E.y)*(C.y - E.y)) /
                   ((F.x - E.x)*(F.x - E.x) + (F.y - E.y)*(F.y - E.y));
        Coord S((F.x + E.x)/2, (F.y + E.y)/2);
        Coord P((F.x - E.x)*t + E.x, (F.y - E.y)*t + E.y);

        if (fabs(S.x - P.x) > 0.1 || fabs(S.y - P.y) > 0.1)
        {
            wxMessageBox(wxS("Nelze sestrojit elipsu. Není splněna kolmost os elipsy, které jsou určeny ohnisky a vedlejším vrcholem."));
            firstPoint = false;
            old2Coord = Coord(INF, INF);
            return;
        }
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Elipse(this, oldCoord, old2Coord, coord, tmpName);

        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();


        objList.push_back(tmp);

        firstPoint = false;
        oldCoord = Coord(INF, INF);
        old2Coord = Coord(INF, INF);

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - první ohnisko"), 1);
        ObjList::iterator i;

        for(i=objList.begin(); i!=objList.end(); ++i)
        {
            if ((*i)->GetType() == oLINE)
            {
                vector<Coord> tmp2 = IntersectionElipse((*i)->GetPos(),
                                                          (*i)->GetPos2(),
                                                          tmp->GetPos(),
                                                          tmp->GetA(),
                                                          tmp->GetB(),
                                                          tmp->GetAlfa());
                int ii;
                for(ii = 0; ii < tmp2.size(); ++ii)
                {
                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                }
            }
//            if ((*i)->GetType() == oCIRCLE)
//            {
//                vector<Coord> tmp2 = IntersectionCircles(oldCoord, radius, (*i)->GetPos(), (*i)->GetRadius());
//                int ii;
//                for(ii = 0; ii < tmp2.size(); ++ii)
//                {
//                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
//                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
//                }
            //}
        }
    }

    if (this->tool == tHYPERBOLE && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - druhe ohnisko"), 1);
    }
    else if (this->tool == tHYPERBOLE && firstPoint && old2Coord == Coord(INF, INF))
    {
        old2Coord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - vedlejší vrchol"), 1);
    }
    else if (this->tool == tHYPERBOLE && firstPoint && old2Coord != Coord(INF, INF))
    {
        Coord C = coord;
        Coord E = oldCoord;
        Coord F = old2Coord;
        double t = ((C.x - E.x)*(F.x - E.x) + (F.y - E.y)*(C.y - E.y)) /
                   ((F.x - E.x)*(F.x - E.x) + (F.y - E.y)*(F.y - E.y));
        Coord S((F.x + E.x)/2, (F.y + E.y)/2);
        Coord P((F.x - E.x)*t + E.x, (F.y - E.y)*t + E.y);
        double b = sqrt((S.x - C.x)*(S.x - C.x) + (S.y - C.y)*(S.y - C.y));
        double e = sqrt((E.x - S.x)*(E.x - S.x) + (E.y - S.y)*(E.y - S.y));

        if (fabs(S.x - P.x) > 0.1 || fabs(S.y - P.y) > 0.1 || b >= e)
        //if (b >= e)
        {
            if (b >=e)
                wxMessageBox(wxS("Nelze sestrojit hyperbolu. Velikost vedlejší poloosy je rovna nebo větší než velikost excentricity."));
            else
                wxMessageBox(wxS("Nelze sestrojit hyperbolu. Vedlejší poloosa procházející vedlejším vrcholem a kolmá na spojnici ohnicek neprochází středem úsečky tvořené ohnisky."));

            firstPoint = false;
            oldCoord = Coord(INF, INF);
            old2Coord = Coord(INF, INF);
            return;
        }
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Hyperbole(this, oldCoord, old2Coord, coord, tmpName);

        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        firstPoint = false;
        old2Coord = Coord(INF, INF);

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - ohnisko"), 1);
        ObjList::iterator i;

        for(i=objList.begin(); i!=objList.end(); ++i)
        {
            if ((*i)->GetType() == oLINE)
            {
                vector<Coord> tmp2 = IntersectionHyperbole((*i)->GetPos(),
                                                          (*i)->GetPos2(),
                                                          tmp->GetPos(),
                                                          tmp->GetA(),
                                                          tmp->GetB(),
                                                          tmp->GetAlfa());
                int ii;
                for(ii = 0; ii < tmp2.size(); ++ii)
                {
                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                }
            }
//            if ((*i)->GetType() == oCIRCLE)
//            {
//                vector<Coord> tmp2 = IntersectionCircles(oldCoord, radius, (*i)->GetPos(), (*i)->GetRadius());
//                int ii;
//                for(ii = 0; ii < tmp2.size(); ++ii)
//                {
//                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
//                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
//                }
            //}
        }
    }

    if (this->tool == tPARABOLA && !firstPoint)
    {
        oldCoord = coord;
        firstPoint = true;

        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - vrchol"), 1);
    }
    else if (this->tool == tPARABOLA && firstPoint)
    {
        //double radius = coord.DistTo(oldCoord);
        wxString tmpName = newName.GetNameOther();
        GeomObj* tmp = new Parabola(this, oldCoord, coord, tmpName);

        ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

        undoList.push_back(CopyObjList());
        if (!rendoList.empty())
            DeleteRList();
        objList.push_back(tmp);
        firstPoint = false;
        ((MainWin*)parent)->SetStatusText(wxS("Kliknout na nákresnu - ohnisko"), 1);
        ObjList::iterator i;
        for(i=objList.begin(); i!=objList.end(); ++i)
        {
            if ((*i)->GetType() == oLINE)
            {
                vector<Coord> tmp2 = IntersectionParabola((*i)->GetPos(),
                                                          (*i)->GetPos2(),
                                                          tmp->GetPos(),
                                                          tmp->GetP(),
                                                          tmp->GetAlfa());
                int ii;
                for(ii = 0; ii < tmp2.size(); ++ii)
                {
                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                }
            }
//            if ((*i)->GetType() == oCIRCLE)
//            {
//                vector<Coord> tmp2 = IntersectionCircles(oldCoord, radius, (*i)->GetPos(), (*i)->GetRadius());
//                int ii;
//                for(ii = 0; ii < tmp2.size(); ++ii)
//                {
//                    pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(tmp, (*i));
//                    intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
//                }
//            }
        }
    }

    if (this->tool == tPERPENDICULAR)
    {
        if (selected == NULL || selected->GetType() != oLINE)
            SelectLine(coord.x, coord.y, 0);
        else
        {
            GeomObj *tmpSelected = selected;
            if (selected != NULL && selected->GetType() == oLINE)
            {
                SelectPoint(coord.x, coord.y);
                if (selected->GetType() != oPOINT)
                {
                    wxString tmpName = newName.GetNameOther();

                    Coord tmp1 = selected->GetPos();
                    Coord tmp2 = selected->GetPos2();
                    if (fabs((coord.x - tmp1.x)/(tmp2.x - tmp1.x) - (coord.y - tmp1.y)/(tmp2.y - tmp1.y)) < 0.1)
                        coord = Coord(coord.x - (tmp2.y - tmp1.y), coord.y + (tmp2.x - tmp1.x));

                    GeomObj *tmp = Line::Perpendicular(this, coord, tmpSelected, tmpName);
                    ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

//                    ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") + tmpName +
//                                                            wxS(" je kolmá na ") + selected->GetName());
                    undoList.push_back(CopyObjList());
                    if (!rendoList.empty())
                        DeleteRList();
                    objList.push_back(tmp);
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos(), tmp));
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos2(), tmp));
                    FindIntersectionLine(tmp->GetPos(), tmp->GetPos2(), tmp);
                    selected = NULL;
                }
//                else
//                {
//                    wxString tmpName = newName.GetNameOther();
//                    GeomObj *tmp = Line::Perpendicular(this, selected->GetPos(), tmpSelected, tmpName);
//                    ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());
//
//                    ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") + tmpName +
//                                                            wxS(" je kolmá na ") + selected->GetName());
//                    undoList.push_back(CopyObjList());
//                    if (!rendoList.empty())
//                        DeleteRList();
//                    objList.push_back(tmp);
//                    endPoints.push_back(pair<Coord, GeomObj*>(selected->GetPos(), tmp));
//                    endPoints.push_back(pair<Coord, GeomObj*>(coord, tmp));
//                    FindIntersectionLine(tmp->GetPos(), tmp->GetPos2(), tmp);
//                    selected = NULL;
//                }
                selected = tmpSelected;
            }
        }
    }

    if (this->tool == tPARALLEL)
    {
        if (selected ==NULL || selected->GetType() != oLINE)
            SelectLine(coord.x, coord.y, 0);
        else
        {
            GeomObj *tmpSelected = selected;
            if (selected != NULL && selected->GetType() == oLINE)
            {
                SelectPoint(coord.x,coord.y);
                if (selected->GetType() != oPOINT)
                {
                    wxString tmpName = newName.GetNameOther();
                    GeomObj *tmp = Line::Parallel(this, coord, tmpSelected, tmpName);
                    ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

//                    ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") + tmpName +
//                                                            wxS(" je rovnoběžná s ") + selected->GetName());
                    undoList.push_back(CopyObjList());
                    if (!rendoList.empty())
                        DeleteRList();
                    objList.push_back(tmp);
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos(), tmp));
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos2(), tmp));
                    FindIntersectionLine(tmp->GetPos(), tmp->GetPos2(), tmp);
                    selected = NULL;
                }
                else
                {
                    wxString tmpName = newName.GetNameOther();
                    GeomObj *tmp = Line::Parallel(this, selected->GetPos(), tmpSelected, tmpName);

                    ((MainWin*)parent)->rightPanel->AddLine(tmp->GetText());

//                    ((MainWin*)parent)->rightPanel->AddLine(tmpName + wxS("; ") + tmpName +
//                                                            wxS(" je rovnoběžná s ") + selected->GetName());
                    undoList.push_back(CopyObjList());
                    if (!rendoList.empty())
                        DeleteRList();
                    objList.push_back(tmp);
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos(), tmp));
                    endPoints.push_back(pair<Coord, GeomObj*>(tmp->GetPos2(), tmp));
                    FindIntersectionLine(tmp->GetPos(), tmp->GetPos2(), tmp);
                    selected = NULL;
                }

                selected = tmpSelected;
            }
        }
    }

    if (this->tool == tSELECT)
    {
        int number = ((MainWin*)parent)->rightPanel->list->GetCount();
        for(int i = 0; i < number; ++i)
            ((MainWin*)parent)->rightPanel->list->Deselect(i);
        if (coord == mouseStart)
        {
            SelectPoint(coord.x, coord.y);
            SelectLine(coord.x, coord.y, 1);
            SelectCircle(coord.x, coord.y);
        }
        else
        {
            listSelected.clear();
            SelectPoints(mouseStart, coord);
            SelectLines(mouseStart, coord);
            SelectCircles(mouseStart, coord);
            SelectEllipses(mouseStart, coord);
            SelectHyperboles(mouseStart, coord);
            SelectParabolas(mouseStart, coord);
            selectNow = false;
        }
    }

    if(this->tool == tEXTEND)
    {
        if (selected == NULL || selected->GetType() != oLINE)
            SelectLine(coord.x, coord.y, 0);
        else
        {
            undoList.push_back(CopyObjList());
            if (!rendoList.empty())
                DeleteRList();
            GeomObj *tmpSelected = selected;
            if (selected != NULL && selected->GetType() == oLINE)
            {
                double ux = selected->GetPos().x - selected->GetPos2().x;
                double uy = selected->GetPos().y - selected->GetPos2().y;

                double t = (-uy*selected->GetPos().x + coord.x*uy + ux*selected->GetPos().y - coord.y*ux) / (ux*ux + uy*uy);
                Coord old;
                if (selected->GetPos().DistTo(lastCoord) < selected->GetPos2().DistTo(lastCoord))
                {
                    old = selected->GetPos();
                    selected->ChangePos(Coord(coord.x - t*uy, coord.y + t*ux));
                }
                else
                {
                    old = selected->GetPos();
                    selected->ChangePos2(Coord(coord.x - t*uy, coord.y + t*ux));
                }
                seznam2::iterator k = endPoints.begin();
                for (k; k != endPoints.end(); )
                {
                    if (old == (*k).first && selected == (*k).second)
                    {
                        endPoints.erase(k);
                    }
                    else
                        ++k;
                }
                endPoints.push_back(pair<Coord,
                                    GeomObj*>(Coord(coord.x - t*uy, coord.y + t*ux),
                                    selected));
                FindIntersectionLine(selected->GetPos(), selected->GetPos2(), selected);

                selected = tmpSelected;
            }
        }
    }

    RefreshSnapPoints();

    this->Refresh();

    mouseStart = Coord(INF, INF);
}
//bere i kliknuti praveho tlacitka mysi / prepsat na jen levy
void EditPanel::OnMouseLeftClickDown(wxMouseEvent& evt)
{
    if (this->tool == tSELECT)
    {
        mouseStart = Coord(this, evt.GetX(), evt.GetY());
        selectNow = true;
    }
}

//urceni zda kurzor bude se prichytavat a kam
void EditPanel::OnMouseMove(wxMouseEvent& evt)
{
    if (evt.Moving())
    {
        mouseStart = Coord(INF, INF);
        mouseCoord = Coord(this, evt.GetX(), evt.GetY());
        //kresleni kurzoru
        if (snap && this->tool != tSELECT)
        {
            mouseCoord.x = SnapX(mouseCoord.x);
            mouseCoord.y = SnapY(mouseCoord.y);
            this->Refresh();
        }
        if (snapEndPoints && this->tool != tSELECT)
        {
            mouseCoord = SnapEndPoints(mouseCoord);
            this->Refresh();
        }
        if (snapIntersect && this->tool != tSELECT)
        {
            mouseCoord = SnapIntersect(mouseCoord);
            this->Refresh();
        }
        if (firstPoint)
            this->Refresh();
    }
    if (evt.Dragging())
    {
        mouseDownCoord = Coord(this, evt.GetX(), evt.GetY());
        //selectNow = true;
        this->Refresh();
    }

}

//vykresleni pomocne mrizky o sirce 100 (nastavitelna)
void EditPanel::PaintGrid(wxDC& dc)
{
    int i,j;
    int widhtPanel, heightPanel;
    this->GetSize(&widhtPanel, &heightPanel);

    int w = gridSize;//20*gridSize;
    //int w = (((MainWin*)parent)->widthGrid);
    dc.SetPen(wxPen(wxColor( 0, 0, 0),1, wxSHORT_DASH));

    int numxMax = (widhtPanel - offsetx)*zoom / w;
    int numyMax = (heightPanel - offsety)* zoom / w;
    int numxMin = (offsetx)*zoom / w;
    int numyMin = (offsety)* zoom / w;
    for (i = -numxMin; i <= numxMax; ++i)
        for (j = -numyMin ; j <= numyMax; ++j)
            {
                if (((MainWin*)parent)->lineGrid)
                {
                    dc.DrawLine(wxCoord(0),                             wxCoord((j*w)/zoom + offsety),
                                wxCoord(widhtPanel),                    wxCoord((j*w)/zoom + offsety));
                    dc.DrawLine(wxCoord((i*w)/zoom + offsetx),            wxCoord(0),
                                wxCoord((i*w)/zoom + offsetx),            wxCoord(heightPanel));
                }
                if (((MainWin*)parent)->pointGrid)
                    dc.DrawPoint(wxPoint((i*w)/zoom + offsetx  , (j*w)/zoom + offsety));

//                dc.DrawPoint(wxPoint((i*w)/zoom + offsetx+1, (j*w)/zoom + offsety));
//                dc.DrawPoint(wxPoint((i*w)/zoom + offsetx-1, (j*w)/zoom + offsety));
//                dc.DrawPoint(wxPoint((i*w)/zoom + offsetx  , (j*w)/zoom + offsety+1));
//                dc.DrawPoint(wxPoint((i*w)/zoom + offsetx  , (j*w)/zoom + offsety-1));
            }
}

void EditPanel::OnMouseWheel(wxMouseEvent& evt)
{
//    wxString str;
//    str << evt.m_wheelRotation << wxT(" ") << evt.m_wheelDelta;
//    wxMessageBox(str);
    if (evt.m_wheelRotation > 0)
        zoom = zoom + 0.01;
    else
        if (zoom > 0)
            zoom = zoom - 0.01;

    this->Refresh();
}

void EditPanel::OnMouseRightClickUp(wxMouseEvent& evt)
{
    Coord tmp = Coord(this, evt.GetX(), evt.GetY());
    if(startMove == tmp)
    {
        if ((this->tool == tEXTEND && selected != NULL) ||
            (this->tool == tPARALLEL && selected != NULL) ||
            (this->tool == tPERPENDICULAR && selected != NULL))
        {
            selected = NULL;
        }
        else
        {
            tool = tSELECT;
            ((MainWin*)parent)->toolPanel->toolBar1->ToggleTool(100, true);
        }
        mouseStart = Coord(INF, INF);
        firstPoint = false;
        startMove = Coord(INF, INF);
    }
    else if (!(startMove == Coord(INF, INF)))
    {
        Coord u = tmp - startMove;
        offsetx = offsetx + u.x;
        offsety = offsety + u.y;

        startMove = Coord(INF, INF);
    }
    this->Refresh();
}

void EditPanel::OnMouseRightClickDown(wxMouseEvent& evt)
{
    startMove = Coord(this, evt.GetX(), evt.GetY());
}

void EditPanel::Open()
{
    ifstream in;

    wxString text = wxS("Jste si jisti, že chtece ukončit tento příklad?");
    wxString caption = wxS("Otevřít");
    wxMessageDialog dialog(this, text, caption, wxICON_QUESTION | wxYES_NO);

    if (dialog.ShowModal() == wxID_NO)
        return;

    wxFileDialog dialog2(this, wxS("Choose a file"), wxS(""), wxS(""), wxS("*.obr"), wxFD_OPEN);

    if (dialog2.ShowModal() == wxID_CANCEL)
        return;

    ObjList::iterator j;
    for (j = objList.begin(); j != objList.end(); ++j)
        delete(*j);
    objList.clear();
    selected = NULL;
    listSelected.clear();
    newName = Name(this);
    Refresh();

    UndoList::iterator i;
    for (i = undoList.begin(); i != undoList.end(); ++i)
    {
        for (j = (*i).begin(); j != (*i).end(); ++j)
            delete(*j);
    }
    DeleteRList();
    rendoList.clear();
    undoList.clear();
    endPoints.clear();
    intersects.clear();
    ((MainWin*)parent)->toolBar->EnableTool(134, false);
    newName = Name(this);
    ((MainWin*)parent)->toolPanel->toolBar1->ToggleTool(100, true);
    tool = tSELECT;

    ((MainWin*)parent)->Upgrade();

    wxString directory = dialog2.GetDirectory();
    wxString file = dialog2.GetFilename();


    wxString adress = (directory +wxS("/")+ file);
    //wxMessageBox(adress);
    //vystup.open(adress.char_str());
    (((MainWin*)parent)->nameFile) = file;
    (((MainWin*)parent)->address) = adress;

    in.open(adress.mb_str());

    //in.open("Obrazek1");
    if (!in.fail())
    {
        while (!in.eof() && !in.fail())
        {
            char typ;
            in >> typ ;
            if (in.eof() || in.fail())
                break;
            if (typ == 'l')
            {
                double xA, yA, xB, yB;
                string name;
                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> xB >> yB >> name >> r >> g >> b >> width >> label >> vis >> change;

                GeomObj *tmp = new Line(this, Coord(xA, yA), Coord(xB, yB),
                                        wxString(name.c_str(),wxConvUTF8),
                                        wxColor(r, g, b));
                objList.push_back(tmp);
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);

                endPoints.push_back(pair<Coord, GeomObj*>(Coord(xA, yA), tmp));
                endPoints.push_back(pair<Coord, GeomObj*>(Coord(xB, yB), tmp));
                FindIntersectionLine(Coord(xB, yB), Coord(xA, yA), tmp);
            }
            else if (typ == 'p')
            {
                double xA, yA;
                string name;
                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> name >> r >> g >> b >> width >> label >> vis >> change;
                Point *tmp = new Point(this, Coord(xA, yA),
                                      wxString(name.c_str(),wxConvUTF8),
                                      wxColor(r, g, b));
                objList.push_back(tmp);
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);
                endPoints.push_back(pair<Coord, GeomObj*>(Coord(xA, yA), tmp));
            }
            else if (typ == 'c')
            {
                double xA, yA, rad;
                string name;
                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> rad >> name >> r >> g >> b >> width >> label >> vis >> change;

                GeomObj *tmp = new Circle(this, Coord(xA, yA), rad,
                                           wxString(name.c_str(),wxConvUTF8),
                                           wxColor(r, g, b));
                objList.push_back(tmp);
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);
                FindIntersectionCircle(Coord(xA, yA), rad, tmp);
            }
            else if (typ == 'e')
            {
                double xA, yA, A, B, alfa;
                string name;

                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> A >> B >> alfa >> name >> r >> g
                   >> b >> width >> label >> vis >> change;

                objList.push_back(new Elipse(this, Coord(xA, yA), A, B, alfa,
                                              wxString(name.c_str(),wxConvUTF8),
                                              wxColor(r, g, b)));
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);
            }
            else if (typ == 'h')
            {
                double xA, yA, A, B, alfa;
                string name;
                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> A >> B >> alfa >> name >> r >> g
                   >> b >> width >> label >> vis >> change;

                objList.push_back(new Hyperbole(this, Coord(xA, yA), A, B, alfa,
                                                wxString(name.c_str(),wxConvUTF8),
                                                wxColor(r, g, b)));
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);
            }
            else if (typ == 'r')
            {
                double xA, yA, P, alfa;
                string name;
                int width, r, g, b;
                bool label, vis, change;
                in >> xA >> yA >> P >> alfa >> name >> r >> g
                   >> b >> width >> label >> vis >> change;

                objList.push_back(new Parabola(this, Coord(xA, yA), P, alfa,
                                               wxString(name.c_str(),wxConvUTF8),
                                               wxColor(r, g, b)));
                objList.back()->ChangeWidth(width);
                objList.back()->SetLabel(label);
                objList.back()->SetVisibility(vis);
                objList.back()->SetChange(change);
            }
        }
        this->Refresh();
        ((MainWin*)parent)->Upgrade();
        in.close();
    }
    else
        wxMessageBox(wxS("Nepodarilo se nacist soubor"));
}

//ulozeni stavajiciho obrazku
wxString EditPanel::Save(wxString address)
{
    ofstream vystup;

    if (address.empty())
    {
        wxFileDialog dialog(this, wxS("Choose a file"), wxS(""), wxS(""), wxS("*.obr"), wxFD_SAVE);
        if (dialog.ShowModal() == wxID_CANCEL)
        {
            return address;
        }
        wxString directory = dialog.GetDirectory();
        wxString file = dialog.GetFilename();
        int pos = file.rfind(wxS(".obr"));
        if (pos != file.length() - 4)
            file = file + wxS(".obr");
        address = (directory +wxS("/")+ file);
        (((MainWin*)parent)->nameFile) = file;
    }

    vystup.open(address.mb_str());

    ObjList::iterator i;
    for (i = objList.begin(); i != objList.end(); ++i)
    {
        if ((*i)->GetType() == oPOINT)
        {
            Coord tmp = (*i)->GetPos();
            vystup << "p " << tmp.x << ' ' << tmp.y << ' ' << " ";
        }
        if ((*i)->GetType() == oLINE)
        {
            Coord tmp = (*i)->GetPos();
            Coord tmp2 = (*i)->GetPos2();
            vystup << "l " << tmp.x << ' ' << tmp.y << ' ' << tmp2.x << ' ' << tmp2.y << ' ';
        }
        if ((*i)->GetType() == oCIRCLE)
        {
            Coord tmp = (*i)->GetPos();
            vystup << "c " << tmp.x << ' ' << tmp.y << ' ' << (*i)->GetRadius() << ' ';
        }
        if ((*i)->GetType() == oELLIPSE)
        {
            Coord tmp = (*i)->GetPos();
            vystup << "e "
                   << tmp.x
                   << ' '
                   << tmp.y
                   << ' '
                   << (*i)->GetA()
                   << ' '
                   << (*i)->GetB()
                   << ' '
                   << (*i)->GetAlfa()
                   << ' ';
        }
        if ((*i)->GetType() == oHYPERBOLE)
        {
            Coord tmp = (*i)->GetPos();
            vystup << "h "
                   << tmp.x
                   << ' '
                   << tmp.y
                   << ' '
                   << (*i)->GetA()
                   << ' '
                   << (*i)->GetB()
                   << ' '
                   << (*i)->GetAlfa()
                   << ' ';
        }
        if ((*i)->GetType() == oPARABOLA)
        {
            Coord tmp = (*i)->GetPos();
            vystup << "r "
                   << tmp.x
                   << ' '
                   << tmp.y
                   << ' '
                   << (*i)->GetP()
                   << ' '
                   << (*i)->GetAlfa()
                   << ' ';
        }
        vystup << (char*)(*i)->GetName().char_str()
               << ' '
               << (int)(*i)->GetColor().Red()
               << ' '
               << (int)(*i)->GetColor().Green()
               << ' '
               << (int)(*i)->GetColor().Blue()
               << ' '
               << (*i)->GetWidth()
               << ' '
               << (*i)->GetLabel()
               << ' '
               << (*i)->GetVisibility()
               << ' '
               << (*i)->GetChange()
               << endl;
    }

    vystup.close();
    return address;
}

ObjList EditPanel::CopyObjList()
{
    ObjList tmp;

    for(int i = 0; i < objList.size(); ++i)
    {
        if (objList[i]->GetType() == oPOINT)
        {
            Point *tmpP = new Point((*(Point*)(objList[i])));
            tmp.push_back(tmpP);
        }
        if (objList[i]->GetType() == oLINE)
        {
            Line *tmpL = new Line((*(Line*)(objList[i])));
            tmp.push_back(tmpL);
        }
        if (objList[i]->GetType() == oCIRCLE)
        {
            Circle *tmpC = new Circle((*(Circle*)(objList[i])));
            tmp.push_back(tmpC);
        }
        if (objList[i]->GetType() == oELLIPSE)
        {
            Elipse *tmpE = new Elipse((*(Elipse*)(objList[i])));
            tmp.push_back(tmpE);
        }
        if (objList[i]->GetType() == oHYPERBOLE)
        {
            Hyperbole *tmpH = new Hyperbole((*(Hyperbole*)(objList[i])));
            tmp.push_back(tmpH);
        }
        if (objList[i]->GetType() == oPARABOLA)
        {
            Parabola *tmpP = new Parabola((*(Parabola*)(objList[i])));
            tmp.push_back(tmpP);
        }
    }


    return tmp;

}

ObjList EditPanel::CopyObjList(ObjList &obj)
{
    ObjList tmp;

    for(int i = 0; i < obj.size(); ++i)
    {
        if (obj[i]->GetType() == oPOINT)
        {
            Point *tmpP = new Point((*(Point*)(obj[i])));
            tmp.push_back(tmpP);
        }
        if (obj[i]->GetType() == oLINE)
        {
            Line *tmpL = new Line((*(Line*)(obj[i])));
            tmp.push_back(tmpL);
        }
        if (obj[i]->GetType() == oCIRCLE)
        {
            Circle *tmpC = new Circle((*(Circle*)(obj[i])));
            tmp.push_back(tmpC);
        }
        if (obj[i]->GetType() == oELLIPSE)
        {
            Elipse *tmpE = new Elipse((*(Elipse*)(obj[i])));
            tmp.push_back(tmpE);
        }
        if (obj[i]->GetType() == oHYPERBOLE)
        {
            Hyperbole *tmpH = new Hyperbole((*(Hyperbole*)(obj[i])));
            tmp.push_back(tmpH);
        }
        if (obj[i]->GetType() == oPARABOLA)
        {
            Parabola *tmpP = new Parabola((*(Parabola*)(obj[i])));
            tmp.push_back(tmpP);
        }
    }
    return tmp;
}

void EditPanel::RefreshSnapPoints()
{
    intersects.clear();
    endPoints.clear();

    for(int i = 0; i < objList.size(); ++i)
    {
        if (objList[i]->GetType() == oPOINT)
        {
            endPoints.push_back(pair<Coord, GeomObj*>(objList[i]->GetPos(), objList[i]));
        }
        if (objList[i]->GetType() == oLINE)
        {
            endPoints.push_back(pair<Coord, GeomObj*>(objList[i]->GetPos(), objList[i]));
            endPoints.push_back(pair<Coord, GeomObj*>(objList[i]->GetPos2(), objList[i]));
            FindIntersectionLine(objList[i]->GetPos(), objList[i]->GetPos2(), objList[i]);
        }
        if (objList[i]->GetType() == oCIRCLE)
        {
            FindIntersectionCircle(objList[i]->GetPos(), objList[i]->GetRadius(), objList[i]);
        }
        if (objList[i]->GetType() == oELLIPSE)
        {
            ObjList::iterator j;
            for(j=objList.begin(); j!=objList.end() && (*j) != objList[i]; ++j)
            {
                if ((*j)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = IntersectionElipse((*j)->GetPos(),
                                                            (*j)->GetPos2(),
                                                            objList[i]->GetPos(),
                                                            objList[i]->GetA(),
                                                            objList[i]->GetB(),
                                                            objList[i]->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(objList[i], (*j));
                        intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
        if (objList[i]->GetType() == oHYPERBOLE)
        {
            ObjList::iterator j;
            for(j=objList.begin(); j!=objList.end() && (*j) != objList[i]; ++j)
            {
                if ((*j)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = IntersectionHyperbole((*j)->GetPos(),
                                                              (*j)->GetPos2(),
                                                              objList[i]->GetPos(),
                                                              objList[i]->GetA(),
                                                              objList[i]->GetB(),
                                                              objList[i]->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(objList[i], (*j));
                        intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
        if (objList[i]->GetType() == oPARABOLA)
        {
            ObjList::iterator j;
            for(j=objList.begin(); j!=objList.end() && (*j) != objList[i]; ++j)
            {
                if ((*j)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = IntersectionParabola((*j)->GetPos(),
                                                              (*j)->GetPos2(),
                                                              objList[i]->GetPos(),
                                                              objList[i]->GetP(),
                                                              objList[i]->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>(objList[i], (*j));
                        intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
    }
}

void EditPanel::DeleteRList()
{
    UndoList::iterator i;
    ObjList::iterator j;
    for (i = rendoList.begin(); i != rendoList.end(); ++i)
    {
        for (j = (*i).begin(); j != (*i).end(); ++j)
            delete(*j);
    }
    rendoList.clear();
    ((MainWin*)parent)->toolBar->EnableTool(134, false);
}

