#include "MainWin.h"
#include "Properties.h"
#include "NewObject.h"
#include "Point.h"
#include "Line.h"
#include "Circle.h"
#include <wx/event.h>
#include <wx/textctrl.h>
#include <wx/spinctrl.h>
#include <string>
#include <list>
#include <sstream>
#include <wx/html/htmlwin.h>


#define INF 1.0/0.0

MainWin::MainWin(const wxString& title)
    : wxFrame(NULL, wxID_ANY, title, wxDefaultPosition, wxSize(750, 600))
{
    editPanel = new EditPanel(this, 0);
    toolPanel = new ToolPanel(this, 1);
    rightPanel = new RightPanel(this, 2);


    menuBar = new wxMenuBar(0);

    menu1 = new wxMenu();

	menu1->Append(10, wxS("&Nový"));
	menu1->Append(11, wxS("Otevřít..."));
	menu1->Append(12, wxS("Uložit"));
	menu1->Append(13, wxS("Uložit jako..."));

	menu1->AppendSeparator();

    menu1->Append(14, wxS("Konec"));

    menuBar->Append(menu1, wxS("&Soubor"));

    menu2 = new wxMenu();

	menu2->Append(20, wxS("Zpět"));
	menu2->Append(21, wxS("Vpřed"));

	menu2->AppendSeparator();

	menu2->Append(22, wxS("Upravit vybranné objekty..."));
	//menu2->Append(23, wxS("Přidat nový..."));
    wxMenu *menu21 = new wxMenu();
	menu21->Append(24, wxS("Bod..."));
	menu21->Append(25, wxS("Přímku..."));
	menu21->Append(26, wxS("Kružnici..."));
    menu2->Append(23, wxS("Přidat nový"), menu21);
    menuBar->Append(menu2, wxS("Úpravy"));


    menu3 = new wxMenu();

	menu3->Append(30, wxS("Zobrazit mřížku"), wxEmptyString, wxITEM_CHECK);
    menu3->Append(31, wxS("Nastavit mřížku..."));
    menu3->Append(32, wxS("Zobrazit osy"), wxEmptyString, wxITEM_CHECK);

    menuBar->Append(menu3, wxS("Zobrazit"));


    menu4 = new wxMenu();

	menu4->Append(40, wxS("Příklady"));

	menu4->Append(41, wxS("Nápověda"));
//
//	menu4->Append(42, wxS("Text teorie"));

	menu4->AppendSeparator();

	menu4->Append(43, wxS("O Programu"));

    menuBar->Append(menu4, wxS("Nápověda"));

    SetMenuBar(menuBar);

//     toolBar = new wxToolBar(this, 1, wxPoint(0, 0),
//                             wxSize(1000, 40), wxTB_HORIZONTAL | wxTB_FLAT);
    toolBar = this->CreateToolBar(wxTB_HORIZONTAL | wxTB_FLAT, 1);

    toolBar->AddTool(130, wxS("Nový"), wxBitmap(wxS("ikony/Novy.png"), wxBITMAP_TYPE_PNG),
                     wxS("Nový"), wxITEM_NORMAL);
    toolBar->AddTool(132, wxS("Otevřít"), wxBitmap(wxS("ikony/Open.png"), wxBITMAP_TYPE_PNG),
                     wxS("Otevřít"), wxITEM_NORMAL);
    toolBar->AddTool(131, wxS("Save"), wxBitmap(wxS("ikony/Save.png"), wxBITMAP_TYPE_PNG),
                     wxS("Ulozit"), wxITEM_NORMAL);
    toolBar->InsertSeparator(3);
    toolBar->AddTool(133, wxS("Undo"), wxBitmap(wxS("ikony/undo.png"), wxBITMAP_TYPE_PNG),
                     wxS("Zpět"), wxITEM_NORMAL);
    toolBar->AddTool(134, wxS("Redo"), wxBitmap(wxS("ikony/redo.png"), wxBITMAP_TYPE_PNG),
                     wxS("Vpřed"), wxITEM_NORMAL);

    toolBar->InsertSeparator(6);

    toolBar->AddTool(108, wxS("Guma"), wxBitmap(wxS("ikony/Guma.png"), wxBITMAP_TYPE_PNG),
                               wxS("Smaže vybrané objekty"), wxITEM_NORMAL);

    toolBar->AddTool(120, wxS("Změna vlastností objektu"), wxBitmap(wxS("ikony/Color.png"), wxBITMAP_TYPE_PNG),
                               wxS("Změní vlastnosti aktulně vybraným objektům"), wxITEM_NORMAL);
    toolBar->AddTool(135, wxS("NewObject"), wxBitmap(wxS("ikony/NovyObjekt.png"), wxBITMAP_TYPE_PNG),
                         wxS("Nový objekt"), wxITEM_NORMAL);

    toolBar->InsertSeparator(10);

    toolBar->AddTool(113, wxS("Bez přichytávání"), wxBitmap(wxS("ikony/BezPrichytavani.png"), wxBITMAP_TYPE_PNG),
                               wxS("Bez přichytávání"), wxITEM_RADIO);
    toolBar->AddTool(104, wxS("Přichytávání k mřížce"), wxBitmap(wxS("ikony/PrichytavaniKMrizce.png"), wxBITMAP_TYPE_PNG),
                               wxS("Přichytávání k mřížce"), wxITEM_RADIO);
    toolBar->AddTool(111, wxS("Přichytávání ke koncovým bodům"), wxBitmap(wxS("ikony/PrichytavaniKeKoncovymBodum.png"), wxBITMAP_TYPE_PNG),
                               wxS("Přichytávání ke koncovým bodům"), wxITEM_RADIO);
    toolBar->AddTool(112, wxS("Přichytávání k průsečíkům"), wxBitmap(wxS("ikony/PrichytavaniKPrusecikum.png"), wxBITMAP_TYPE_PNG),
                               wxS("Přichytávání k průsečíkům"), wxITEM_RADIO);


    toolBar->EnableTool(134, false);

    toolBar->Realize();

//    textLine = new wxTextCtrl(this, 19, wxT(""));
//    btnControl = new wxButton(this, 20, wxT("OK"));

    // Sizers
    vsizer = new wxBoxSizer(wxVERTICAL);
    hsizer = new wxBoxSizer(wxHORIZONTAL);
    textLineSizer = new wxBoxSizer(wxHORIZONTAL);

    vsizer->Add(hsizer, wxSizerFlags(1).Expand());
    vsizer->Add(textLineSizer, wxSizerFlags(0).Expand().Border(wxALL, 3));

    hsizer->Add( toolPanel, wxSizerFlags(0).Expand());
    hsizer->Add( editPanel, wxSizerFlags(1).Expand().Border(wxALL, 5));
    hsizer->Add(rightPanel, wxSizerFlags(0).Expand().Border(wxALL, 5));

//    textLineSizer->Add(textLine, wxSizerFlags(1));
//    textLineSizer->Add(btnControl, wxSizerFlags(0));

    this->SetSizer(vsizer);
    snap = wxS("žádné ");
    tool = wxS("výběr");
    statusBar = CreateStatusBar(2);
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj výběr"), 0);
    SetStatusText(wxS("Objekty vyberete pomocí kliknutí a tažení"), 1);

    widthGrid = 10;
    axis = false;
    grid = false;
    pointGrid = true;
    lineGrid = false;
    nameFile = wxS("Nový");
    //Centre();
}

void MainWin::OnBtnPoint(wxCommandEvent& evt)
{
    editPanel->tool = tPOINT;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("bod");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu"), 1);

    editPanel->selected = NULL;
    this->Refresh();
}

void MainWin::OnBtnLine(wxCommandEvent& evt)
{

    editPanel->tool = tLINE;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("přímka");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu pro první bod"), 1);

    editPanel->selected = NULL;
    this->Refresh();
}

void MainWin::OnBtnCompasses(wxCommandEvent & evt)
{
    editPanel->tool = tCOMPASSES;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("kružítko");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu pro první bod, zadávající poloměr"), 1);
    this->Refresh();
}

void MainWin::OnBtnCircle(wxCommandEvent& evt)
{
    editPanel->tool = tCIRCLE;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("kružnice");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu pro střed"), 1);
    this->Refresh();
}

void MainWin::OnBtnElipse(wxCommandEvent &evt)
{
    editPanel->tool = tELLIPSE;

    editPanel->firstPoint = false;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    editPanel->selected = NULL;
    tool = wxS("elipsa");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu pro střed"), 1);
    this->Refresh();

    editPanel->selected = NULL;
}

void MainWin::OnBtnHyperbole(wxCommandEvent &evt)
{
    editPanel->tool = tHYPERBOLE;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("hyperbola");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu pro střed"), 1);
    this->Refresh();

    editPanel->selected = NULL;
}

void MainWin::OnBtnParabola(wxCommandEvent &evt)
{
    editPanel->tool = tPARABOLA;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("parabola");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Kliknout na nákresnu - ohnisko"), 1);
    this->Refresh();

    editPanel->selected = NULL;
}

void MainWin::OnBtnSelect(wxCommandEvent& evt)
{

    editPanel->tool = tSELECT;

    editPanel->firstPoint = false;
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("výběr");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Výběr kliknutím a tažením"), 1);
    this->Refresh();
}

void MainWin::OnBtnSnap(wxCommandEvent& evt)
{
    editPanel->snap = true;
//    editPanel->snap = !editPanel->snap;
//    if (editPanel->snap)
//    {
    editPanel->snapEndPoints = false;
    editPanel->snapIntersect = false;
//    }
    snap = wxS("k mřížce ");

    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    editPanel->Refresh();
}

void MainWin::OnBtnDelete(wxCommandEvent& evt)
{
    ObjList::iterator i;
    ObjList::iterator j;
    seznam2::iterator k2;
    seznam3::iterator k3;
    GeomObj *tmp;
    if (!editPanel->listSelected.empty())
    {
        while (!editPanel->listSelected.empty())
        {
            j = editPanel->listSelected.begin();
            for (i = editPanel->objList.begin(); i != editPanel->objList.end(); ++i)
            {
                if ((*j) == (*i) && (*i)->GetChange())
                {
                    k2 = editPanel->endPoints.begin();
                    for (k2; k2 != editPanel->endPoints.end(); )
                    {
                        if ((*i)->GetName() == (*k2).second->GetName())
                        {
                            editPanel->endPoints.erase(k2);
                        }
                        else
                            ++k2;
                    }
                    k3 = editPanel->intersects.begin();
                    for (k3; k3 != editPanel->intersects.end(); )
                    {
                        if ((*i)->GetName() == (*k3).second.first->GetName() ||
                            (*i)->GetName() == (*k3).second.second->GetName())
                        {
                            editPanel->intersects.erase(k3);
                        }
                        else
                            ++k3;
                    }
                    tmp = (*i);
                    editPanel->objList.erase(i);
                    delete(tmp);
                    break;
                }
            }
            editPanel->listSelected.erase(j);
        }
        editPanel->Refresh();
        Upgrade();
    }

}

void MainWin::OnBtnPerpendicular(wxCommandEvent& evt)
{
    editPanel->tool = tPERPENDICULAR;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("kolmice");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Vybrat přímku, ke které bude kolmá, a bod, kterým prochází"), 1);

    editPanel->selected = NULL;
}

void MainWin::OnBtnParallel(wxCommandEvent& evt)
{
    editPanel->tool = tPARALLEL;
    editPanel->firstPoint = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("rovnoběžka");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Vybrat přímku, ke keteré bude rovnoběžná, a bod, kterým prochází"), 1);

    editPanel->selected = NULL;
}

void MainWin::OnBtnExtend(wxCommandEvent& evt)
{
    editPanel->tool = tEXTEND;
    editPanel->firstPoint = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    tool = wxS("prodlužování");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    SetStatusText(wxS("Vyberte přímku v té polovině, kde ji chcete nechat"), 1);
}

void MainWin::OnBtnSnapEndPoints(wxCommandEvent& evt)
{
    editPanel->snapEndPoints = true;
    editPanel->snapIntersect = false;
    editPanel->snap = false;

    snap = wxS("ke koncovým bodům ");

    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    editPanel->Refresh();
}

void MainWin::OnBtnSnapIntersect(wxCommandEvent& evt)
{
    editPanel->snapIntersect = true;
    editPanel->snapEndPoints = false;
    editPanel->snap = false;

    snap = wxS("k průsečíkům ");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
    editPanel->Refresh();
}

void MainWin::OnBtnNoSnap(wxCommandEvent& evt)
{
    editPanel->snap = false;
    editPanel->snapEndPoints = false;
    editPanel->snapIntersect = false;
    editPanel->Refresh();
    snap = wxS("žádné");
    SetStatusText(wxS("Přichytnutí ") + snap + wxS(" | ") + wxS("Nástroj ") + tool, 0);
}

void MainWin::OnBtnChange(wxCommandEvent& evt)
{
    if (!editPanel->listSelected.empty())
    {
        editPanel->undoList.push_back(editPanel->CopyObjList());
        //editPanel->objList = editPanel->CopyObjList();
        Properties prop(this, editPanel->listSelected);
        //...
        int pom = prop.ShowModal();
        if (pom != wxID_OK)
        {
            //editPanel->objList.clear();
            editPanel->objList = editPanel->undoList.back();
            //editPanel->rendoList.push_back(editPanel->undoList.back());
            editPanel->undoList.pop_back();
        }
    }

    editPanel->Refresh();
    Upgrade();

    wxString tmp2 = nameFile + wxS("* : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnOpen(wxCommandEvent& evt)
{
    editPanel->Open();
    wxString tmp2 = nameFile + wxS(" : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnNew(wxCommandEvent& evt)
{
    if (!editPanel->objList.empty())
    {
        wxString text = wxS("Jste si jisti, že chtece ukončit tento příklad?");
        wxString caption = wxS("Nový");
        wxMessageDialog dialog(this, text, caption, wxICON_QUESTION | wxYES_NO);

        if (dialog.ShowModal() == wxID_NO)
            return;
    }

    ObjList::iterator j;
    for (j = editPanel->objList.begin(); j != editPanel->objList.end(); ++j)
        delete(*j);
    editPanel->objList.clear();
    editPanel->selected = NULL;
    editPanel->oldCoord = Coord(INF, INF);
    editPanel->old2Coord = Coord(INF, INF);
    editPanel->listSelected.clear();
    editPanel->endPoints.clear();
    editPanel->intersects.clear();
    editPanel->Refresh();

    UndoList::iterator i;

    for (i = editPanel->undoList.begin(); i != editPanel->undoList.end(); ++i)
    {
        for (j = (*i).begin(); j != (*i).end(); ++j)
            delete(*j);
    }
    editPanel->DeleteRList();
    editPanel->rendoList.clear();
    editPanel->undoList.clear();
    toolBar->EnableTool(134, false);
    editPanel->newName = Name(editPanel);
    toolPanel->toolBar1->ToggleTool(100, true);
    editPanel->tool = tSELECT;
    address.clear();
    Upgrade();

}

void MainWin::Upgrade()
{
    rightPanel->items.Clear();
    rightPanel->list->Clear();
    ObjList::iterator i;
    wxString tmp;
    for (i = editPanel->objList.begin(); i != editPanel->objList.end(); ++i)
    {
        if ((*i)->GetVisibility())
            tmp = (*i)->GetText();
        else
            tmp = wxS("*") + (*i)->GetText();
        rightPanel->AddLine(tmp);
    }
}

void MainWin::OnBtnUndo(wxCommandEvent& evt)
{
    if (!editPanel->undoList.empty())
    {
        toolBar->EnableTool(134, true);
        editPanel->rendoList.push_back(editPanel->CopyObjList(editPanel->objList));
        editPanel->objList = editPanel->CopyObjList(editPanel->undoList.back());
        editPanel->RefreshSnapPoints();
        editPanel->undoList.pop_back();
        editPanel->Refresh();
        Upgrade();
        if (editPanel->rendoList.empty())
            toolBar->EnableTool(134, false);
    }

    if (editPanel->rendoList.back().size() > editPanel->objList.size())
    {
        ObjList::iterator last = editPanel->rendoList.back().end();
        --last;

        seznam2::iterator k2 = editPanel->endPoints.begin();
        if ((*last)->GetType() == oPOINT || (*last)->GetType() == oLINE)
            for (k2; k2 != editPanel->endPoints.end(); )
            {
                if ((*last)->GetName() == (*k2).second->GetName())
                {
                    editPanel->endPoints.erase(k2);
                }
                else
                    ++k2;
            }
        seznam3::iterator k3 = editPanel->intersects.begin();
        for (k3; k3 != editPanel->intersects.end(); )
        {
            if ((*last)->GetName() == (*k3).second.first->GetName() ||
                (*last)->GetName() == (*k3).second.second->GetName())
            {
                editPanel->intersects.erase(k3);
            }
            else
                ++k3;
        }
    }

    editPanel->selected = NULL;
    wxString tmp2 = nameFile + wxS("* : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnRedo(wxCommandEvent& evt)
{
    if (!editPanel->rendoList.empty())
    {
        editPanel->undoList.push_back(editPanel->CopyObjList(editPanel->objList));
        editPanel->objList = editPanel->CopyObjList(editPanel->rendoList.back());
        editPanel->RefreshSnapPoints();
        editPanel->rendoList.pop_back();
        editPanel->Refresh();
        Upgrade();
        if (editPanel->rendoList.empty())
            toolBar->EnableTool(134, false);
    }

    if (editPanel->undoList.back().size() < editPanel->objList.size())
    {
        ObjList::iterator last = editPanel->objList.end();
        --last;
        if ((*last)->GetType() == oPOINT)
        {
            editPanel->endPoints.push_back(pair<Coord, GeomObj*>((*last)->GetPos(), (*last)));
        }
        if ((*last)->GetType() == oLINE)
        {
            editPanel->endPoints.push_back(pair<Coord, GeomObj*>((*last)->GetPos(), (*last)));
            editPanel->endPoints.push_back(pair<Coord, GeomObj*>((*last)->GetPos2(), (*last)));
            editPanel->FindIntersectionLine((*last)->GetPos(), (*last)->GetPos2(), (*last));
        }
        if ((*last)->GetType() == oCIRCLE)
        {
            editPanel->FindIntersectionCircle((*last)->GetPos(), (*last)->GetRadius(), (*last));
        }
        if ((*last)->GetType() == oELLIPSE)
        {
            ObjList::iterator i;

            for(i = editPanel->objList.begin(); i != editPanel->objList.end(); ++i)
            {
                if ((*i)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = editPanel->IntersectionElipse((*i)->GetPos(),
                                                              (*i)->GetPos2(),
                                                              (*last)->GetPos(),
                                                              (*last)->GetA(),
                                                              (*last)->GetB(),
                                                              (*last)->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>((*last), (*i));
                        editPanel->intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
        if ((*last)->GetType() == oHYPERBOLE)
        {
            ObjList::iterator i;

            for(i = editPanel->objList.begin(); i != editPanel->objList.end(); ++i)
            {
                if ((*i)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = editPanel->IntersectionHyperbole((*i)->GetPos(),
                                                              (*i)->GetPos2(),
                                                              (*last)->GetPos(),
                                                              (*last)->GetA(),
                                                              (*last)->GetB(),
                                                              (*last)->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>((*last), (*i));
                        editPanel->intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
        if ((*last)->GetType() == oPARABOLA)
        {
            ObjList::iterator i;

            for(i = editPanel->objList.begin(); i != editPanel->objList.end(); ++i)
            {
                if ((*i)->GetType() == oLINE)
                {
                    vector<Coord> tmp2 = editPanel->IntersectionParabola((*i)->GetPos(),
                                                              (*i)->GetPos2(),
                                                              (*last)->GetPos(),
                                                              (*last)->GetP(),
                                                              (*last)->GetAlfa());
                    int ii;
                    for(ii = 0; ii < tmp2.size(); ++ii)
                    {
                        pair<GeomObj*, GeomObj*> pom = pair<GeomObj*, GeomObj*>((*last), (*i));
                        editPanel->intersects.push_back(pair<Coord, pair<GeomObj*, GeomObj*> > (tmp2[ii], pom));
                    }
                }
            }
        }
    }

    editPanel->selected = NULL;
    wxString tmp2 = nameFile + wxS("* : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnNewPoint(wxCommandEvent &evt)
{
    NewObject(0);
}

void MainWin::OnBtnNewLine(wxCommandEvent &evt)
{
    NewObject(1);
}

void MainWin::OnBtnNewCircle(wxCommandEvent &evt)
{
    NewObject(2);
}

void MainWin::OnBtnNewObject(wxCommandEvent &evt)
{
    NewObject(3);
}

void MainWin::NewObject(int t)
{
    DialogNovy dialogNovy(this);

    if (t != 3)
        dialogNovy.notebook->ChangeSelection(t);

    if (dialogNovy.ShowModal() == wxID_CANCEL)
        return;

    int typ = dialogNovy.notebook->GetSelection();

    //je vybran bod
    if (typ == 0)
    {
        wxString name = editPanel->newName.GetNamePoint();
        wxColor color = dialogNovy.colourPicker1->GetColour();
        int width = dialogNovy.slider1->GetValue();
        double xA, yA;
        wxString text = dialogNovy.textCtrl11->GetValue();
        stringstream S;
        S << text.char_str();
        S >> xA;
        if (S.fail() || !S.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl12->GetValue();
        stringstream SS;
        SS << text.char_str();
        SS >> yA;
        if (SS.fail() || !SS.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        GeomObj *point = new Point(editPanel, Coord(xA, -yA), name, color);
        point->ChangeWidth(width);
        editPanel->undoList.push_back(editPanel->objList);
        editPanel->objList = editPanel->CopyObjList();
        editPanel->RefreshSnapPoints();
        if (!editPanel->rendoList.empty())
            editPanel->DeleteRList();
        editPanel->objList.push_back(point);
        Upgrade();
        editPanel->Refresh();
    }
    if (typ == 1)
    {
        wxString name = editPanel->newName.GetNameOther();
        wxColor color = dialogNovy.colourPicker2->GetColour();
        int width = dialogNovy.slider2->GetValue();
        double xA, yA, xB, yB;
        wxString text = dialogNovy.textCtrl21->GetValue();
        stringstream S;
        S << text.char_str();
        S >> xA;
        if (S.fail() || !S.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl22->GetValue();
        stringstream SS;
        SS << text.char_str();
        SS >> yA;
        if (SS.fail() || !SS.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl23->GetValue();
        stringstream SSS;
        SSS << text.char_str();
        SSS >> xB;
        if (SSS.fail() || !SSS.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl24->GetValue();
        stringstream SSSS;
        SSSS << text.char_str();
        SSSS >> yB;
        if (SSSS.fail() || !SSSS.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        GeomObj *line = new Line(editPanel, Coord(xA, -yA), Coord(xB, -yB), name, color);
        line->ChangeWidth(width);
        editPanel->undoList.push_back(editPanel->objList);
        editPanel->objList = editPanel->CopyObjList();
        editPanel->RefreshSnapPoints();
        if (!editPanel->rendoList.empty())
            editPanel->DeleteRList();
        editPanel->objList.push_back(line);
        Upgrade();
        editPanel->Refresh();
    }
    if (typ == 2)
    {
        wxString name = editPanel->newName.GetNameOther();
        wxColor color = dialogNovy.colourPicker3->GetColour();
        int width = dialogNovy.slider3->GetValue();
        double xA, yA, rad;
        wxString text = dialogNovy.textCtrl31->GetValue();
        stringstream S;
        S << text.char_str();
        S >> xA;
        if (S.fail() || !S.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl32->GetValue();
        stringstream SS;
        SS << text.char_str();
        SS >> yA;
        if (SS.fail() || !SS.eof())
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        text = dialogNovy.textCtrl33->GetValue();
        stringstream SSS;
        SSS << text.char_str();
        SSS >> rad;
        if (SSS.fail() || !SSS.eof() || rad <= 0)
        {
            wxMessageBox(wxS("Spatný vstup"));
            return;
        }
        GeomObj *circle = new Circle(editPanel, Coord(xA, -yA), rad, name, color);
        circle->ChangeWidth(width);
        editPanel->undoList.push_back(editPanel->objList);
        editPanel->objList = editPanel->CopyObjList();
        editPanel->RefreshSnapPoints();
        if (!editPanel->rendoList.empty())
            editPanel->DeleteRList();
        editPanel->objList.push_back(circle);
        Upgrade();
        editPanel->Refresh();
    }
    wxString tmp2 = nameFile + wxS("* : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}
void MainWin::OnBtnGrid(wxCommandEvent &evt)
{
    if (menu3->IsChecked(30))
        grid = true;
    else
        grid = false;
    editPanel->Refresh();
}

void MainWin::OnBtnAxis(wxCommandEvent &evt)
{
    if (menu3->IsChecked(32))
        axis = true;
    else
        axis = false;
    editPanel->Refresh();
}

void MainWin::OnBtnSetGrid(wxCommandEvent &evt)
{
    Dialog2 dialog(this);

    if (pointGrid)
        dialog.m_radioBox1->SetSelection(0);
    if (lineGrid)
        dialog.m_radioBox1->SetSelection(1);

    dialog.m_spinCtrl4->SetValue(editPanel->gridSize);

    if (dialog.ShowModal() == wxID_CANCEL)
        return;

    int typ = dialog.m_radioBox1->GetSelection();
    if (typ == 0)
    {
        pointGrid = true;
        lineGrid = false;
    }
    if (typ == 1)
    {
        pointGrid = false;
        lineGrid = true;
    }

    editPanel->gridSize = dialog.m_spinCtrl4->GetValue();

    editPanel->Refresh();
}

void MainWin::OnBtnSave(wxCommandEvent &evt)
{
    address = editPanel->Save(address);
    wxString tmp2 = nameFile + wxS(" : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnSaveAs(wxCommandEvent &evt)
{
    wxString tmp;
    tmp = editPanel->Save(tmp);
    if (tmp.empty() && !address.empty())
        return;
    else
        address = tmp;
    wxString tmp2 = nameFile + wxS(" : Editor zaměřený na kuželosečky");
    this->SetTitle(tmp2);
}

void MainWin::OnBtnExamples(wxCommandEvent &evt)
{
    wxDialog *dialog = new wxDialog(this, 0, wxS("Příklady"), wxDefaultPosition, wxDefaultSize);

    wxHtmlWindow *html = new wxHtmlWindow(dialog, -1, wxDefaultPosition, wxSize(900, 600));
    wxFileName examples = wxFileName(wxS("TextKPrikladum/node1.html"));

    html->LoadFile(examples);

    dialog->Fit();
    dialog->Show();
}

void MainWin::OnBtnHelp(wxCommandEvent &evt)
{
    wxDialog *dialog = new wxDialog(this, 0, wxS("Nápověda"), wxDefaultPosition, wxDefaultSize);

    wxHtmlWindow *html = new wxHtmlWindow(dialog, -1, wxDefaultPosition, wxSize(900, 600));
    wxFileName help = wxFileName(wxS("Napoveda/node1.html"));
    
    html->LoadFile(help);

    dialog->Fit();
    dialog->Show();
}

//void MainWin::OnBtnText(wxCommandEvent &evt)
//{
//
//}

void MainWin::OnBtnAbout(wxCommandEvent &evt)
{
    wxMessageBox(wxS("Systém pro podporu výuky kuželoseček \nverze 1.0 \n\nautor: Eliška Hejlová \n\nProgram vznikl jako bakalářská práce na MFF UK 2011"), wxS("O programu"));
}

void MainWin::OnBtnClose(wxCommandEvent &evt)
{
    Close();
}

BEGIN_EVENT_TABLE(MainWin, wxFrame)

    EVT_TOOL(100,MainWin::OnBtnSelect)

    EVT_TOOL(101,MainWin::OnBtnPoint)

    EVT_TOOL(102,MainWin::OnBtnLine)

    EVT_TOOL(103,MainWin::OnBtnCircle)

    EVT_TOOL(117,MainWin::OnBtnCompasses)

    EVT_TOOL(104,MainWin::OnBtnSnap)

    EVT_TOOL(105,MainWin::OnBtnPerpendicular)

    EVT_TOOL(106,MainWin::OnBtnParallel)

    EVT_TOOL(107,MainWin::OnBtnLine)

    EVT_TOOL(131,MainWin::OnBtnSave)
    EVT_MENU(12,MainWin::OnBtnSave)

    EVT_MENU(13,MainWin::OnBtnSaveAs)

    EVT_TOOL(108,MainWin::OnBtnDelete)

    EVT_TOOL(110,MainWin::OnBtnExtend)

    EVT_TOOL(111,MainWin::OnBtnSnapEndPoints)

    EVT_TOOL(112,MainWin::OnBtnSnapIntersect)

    EVT_TOOL(113,MainWin::OnBtnNoSnap)

    EVT_TOOL(120,MainWin::OnBtnChange)
    EVT_MENU(22,MainWin::OnBtnChange)

    EVT_TOOL(132,MainWin::OnBtnOpen)
    EVT_MENU(11,MainWin::OnBtnOpen)

    EVT_TOOL(130,MainWin::OnBtnNew)
    EVT_MENU(10,MainWin::OnBtnNew)

    EVT_TOOL(133,MainWin::OnBtnUndo)
    EVT_MENU(20,MainWin::OnBtnUndo)

    EVT_TOOL(134,MainWin::OnBtnRedo)
    EVT_MENU(21,MainWin::OnBtnUndo)

    EVT_TOOL(135,MainWin::OnBtnNewObject)
    EVT_MENU(23,MainWin::OnBtnNewObject)
    EVT_MENU(24,MainWin::OnBtnNewPoint)

    EVT_MENU(25,MainWin::OnBtnNewLine)
    EVT_MENU(26,MainWin::OnBtnNewCircle)

    EVT_MENU(30,MainWin::OnBtnGrid)

    EVT_MENU(32,MainWin::OnBtnAxis)

    EVT_MENU(31,MainWin::OnBtnSetGrid)

    EVT_TOOL(114,MainWin::OnBtnElipse)

    EVT_TOOL(115,MainWin::OnBtnHyperbole)

    EVT_TOOL(116,MainWin::OnBtnParabola)

    EVT_MENU(40,MainWin::OnBtnExamples)

    EVT_MENU(41,MainWin::OnBtnHelp)
//
//    EVT_MENU(42,MainWin::OnBtnText)

    EVT_MENU(43,MainWin::OnBtnAbout)

    EVT_MENU(14,MainWin::OnBtnClose)

END_EVENT_TABLE()

