#ifndef MAINWIN_H
#define MAINWIN_H

#include <wx/wx.h>
#include "SmallClasses.h"
#include "GeomObj.h"
#include "EditPanel.h"
#include "ToolPanel.h"
#include "RightPanel.h"


using namespace std;


class MainWin : public wxFrame
{
public:
    MainWin(const wxString& title);
    wxBoxSizer *vsizer;
    wxBoxSizer *hsizer;
    wxToolBar  *toolBar;
    EditPanel  *editPanel;
    ToolPanel  *toolPanel; //panel s tlacitky a ovladanim
    RightPanel *rightPanel;
    wxBoxSizer *textLineSizer;
    wxTextCtrl *textLine;
    wxButton   *btnControl;
    wxStatusBar *statusBar;
    wxMenuBar *menuBar;
    wxMenu *menu1, *menu2, *menu3, *menu4;
    wxString snap, tool;
    bool grid, axis;
    bool pointGrid, lineGrid;
    int widthGrid;
    wxString address, nameFile;
    void Upgrade();

private:
    void OnBtnPoint(wxCommandEvent& evt);
    void OnBtnLine(wxCommandEvent& evt);
    void OnBtnCircle(wxCommandEvent& evt);
    void OnBtnCompasses(wxCommandEvent & evt);
    void OnBtnElipse(wxCommandEvent &evt);
    void OnBtnHyperbole(wxCommandEvent &evt);
    void OnBtnParabola(wxCommandEvent &evt);
    void OnBtnSelect(wxCommandEvent& evt);
    void OnBtnSnap(wxCommandEvent& evt);
    void OnBtnDelete(wxCommandEvent& evt);
    void OnBtnPerpendicular(wxCommandEvent& evt);
    void OnBtnParallel(wxCommandEvent& evt);
    void OnBtnSave(wxCommandEvent& evt);
    void OnBtnSaveAs(wxCommandEvent &evt);
    void OnBtnExtend(wxCommandEvent& evt);
    void OnBtnSnapEndPoints(wxCommandEvent& evt);
    void OnBtnSnapIntersect(wxCommandEvent& evt);
    void OnBtnNoSnap(wxCommandEvent& evt);
    void OnBtnChange(wxCommandEvent& evt);
    void OnBtnOpen(wxCommandEvent& evt);
    void OnBtnNew(wxCommandEvent& evt);
    void OnBtnUndo(wxCommandEvent& evt);
    void OnBtnRedo(wxCommandEvent& evt);
    void OnBtnGrid(wxCommandEvent &evt);
    void OnBtnAxis(wxCommandEvent &evt);
    void OnBtnSetGrid(wxCommandEvent &evt);
    void OnBtnNewObject(wxCommandEvent &evt);
    void OnBtnNewPoint(wxCommandEvent &evt);
    void OnBtnNewLine(wxCommandEvent &evt);
    void OnBtnNewCircle(wxCommandEvent &evt);
    void NewObject(int t);
    void OnBtnExamples(wxCommandEvent &evt);
    void OnBtnHelp(wxCommandEvent &evt);
//    void OnBtnText(wxCommandEvent &evt);
    void OnBtnAbout(wxCommandEvent &evt);
    void OnBtnClose(wxCommandEvent &evt);

    DECLARE_EVENT_TABLE();

};

#endif
