#include "RightPanel.h"
#include "EditPanel.h"
#include "MainWin.h"

RightPanel::RightPanel(wxWindow *parent,
                       wxWindowID winid,
                       const wxPoint& pos,
                       const wxSize& size,
                       long style,
                       const wxString& name)
    : wxPanel(parent, winid, pos, size, style, name)
{
    list = new wxListBox(this, 1, wxDefaultPosition, wxSize(150, -1),
                         0, NULL, wxLB_MULTIPLE);

    sizer = new wxBoxSizer(wxVERTICAL);

    allSelect = false;

    this->parent = parent;
    selectAll = new wxButton(this, 2, wxS("Vybrat vše"));
    //items.Add(wxS("select all"));
    list->Set(items);

    sizer->Add(selectAll, wxSizerFlags(0).Expand());
    sizer->Add(list, wxSizerFlags(1).Expand());

    this->SetSizer(sizer);
}

void RightPanel::AddLine(wxString text)
{
    items.Add(text);
    list->Set(items);
}

void RightPanel::OnClick(wxCommandEvent &evt)
{
    ((MainWin*)parent)->editPanel->listSelected.clear();
    int number = list->GetCount();
    ObjList::iterator j = ((MainWin*)parent)->editPanel->objList.begin();
    for(int i = 0; i < number; ++i)
    {
        if (list->IsSelected(i))
            ((MainWin*)parent)->editPanel->listSelected.push_back(*j);
        ++j;
    }
    ((MainWin*)parent)->editPanel->Refresh();
}

void RightPanel::OnSelectAll(wxCommandEvent& evt)
{
    allSelect = !allSelect;
    int number = list->GetCount();
    ObjList::iterator j = ((MainWin*)parent)->editPanel->objList.begin();
    if (allSelect)
    {
        for(int i = 0; i < number; ++i)
        {
            ((MainWin*)parent)->editPanel->listSelected.push_back(*j);
            list->SetSelection(i);
            ++j;
        }
        ((MainWin*)parent)->editPanel->Refresh();
    }
    else
    {
        for(int i = 0; i < number; ++i)
        {
            ((MainWin*)parent)->editPanel->listSelected.pop_back();
            list->Deselect(i);
            //++j;
        }
        ((MainWin*)parent)->editPanel->Refresh();
    }
}

BEGIN_EVENT_TABLE(RightPanel, wxPanel)

    EVT_LISTBOX(1,RightPanel::OnClick)

    EVT_BUTTON(2,RightPanel::OnSelectAll)

END_EVENT_TABLE()
