#include "ToolPanel.h"

ToolPanel::ToolPanel(wxWindow *parent,
                     wxWindowID winid,
                     const wxPoint& pos,
                     const wxSize& size,
                     long style,
                     const wxString& name)
    : wxPanel(parent, winid, pos, size, style, name)
{
    sizer = new wxBoxSizer(wxHORIZONTAL);
    toolBar1 = new wxToolBar(this, 1, wxDefaultPosition, wxDefaultSize, wxTB_VERTICAL | wxTB_FLAT);
    //toolBar2 = new wxToolBar(this, 2, wxDefaultPosition, wxDefaultSize, wxTB_VERTICAL | wxTB_FLAT);

    sizer->Add(toolBar1, wxSizerFlags(0).Expand());
    //sizer->Add(toolBar2, wxSizerFlags(0).Expand());
    this->SetSizer(sizer);

    wxInitAllImageHandlers();

    toolBar1->AddTool(100, wxS("Výber"), wxBitmap(wxS("ikony/Vyber.png"), wxBITMAP_TYPE_PNG),
                               wxS("Stisknutím levého tlačítka myši a tažením vybíráte objekty"), wxITEM_RADIO);

    toolBar1->AddTool(101, wxS("Bod"), wxBitmap(wxS("ikony/Bod.png"), wxBITMAP_TYPE_PNG),
                               wxS("Po kliknutí myši se vytvoří nový bod"), wxITEM_RADIO);
    toolBar1->AddTool(102, wxS("Přímka"), wxBitmap(wxS("ikony/Primka.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří úsečku danou krajními body"), wxITEM_RADIO);
    toolBar1->AddTool(105, wxS("Kolmice"), wxBitmap(wxS("ikony/Kolmice.png"), wxBITMAP_TYPE_PNG),
                               wxS("K dane přímce ze zvoleného bodu vytvoří kolmici"), wxITEM_RADIO);
    toolBar1->AddTool(106, wxS("Rovnoběžka"), wxBitmap(wxS("ikony/Rovnobezky.png"), wxBITMAP_TYPE_PNG),
                               wxS("K dané přímce ze zvoleného bodu vytvoří rovnoběku"), wxITEM_RADIO);
    toolBar1->AddTool(110, wxS("Krácení"), wxBitmap(wxS("ikony/Kraceni.png"), wxBITMAP_TYPE_PNG),
                               wxS("Klikněte pro výběr přímky na část, kterou chcete krátit a kliknete o kolik chcete krátit"), wxITEM_RADIO);
    toolBar1->AddTool(103, wxS("Kružnice"), wxBitmap(wxS("ikony/Kruznice.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří kružnici danou středem a bodem na kružnici"), wxITEM_RADIO);
    toolBar1->AddTool(117, wxS("Kružítko"), wxBitmap(wxS("ikony/Kruzitko.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří kružnici s poloměrem, který je zadaný dvěmi body, a daným středem"), wxITEM_RADIO);
    toolBar1->AddTool(114, wxS("Elipsa"), wxBitmap(wxS("ikony/Elipsa.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří elipsu zadanou ohnisky a vedlejším vrcholem"), wxITEM_RADIO);
    toolBar1->AddTool(115, wxS("Hyperbola"), wxBitmap(wxS("ikony/Hyperbola.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří hyperbolu zadanou ohnisky a vedlejším vrcholem"), wxITEM_RADIO);
    toolBar1->AddTool(116, wxS("Parabola"), wxBitmap(wxS("ikony/Parabola.png"), wxBITMAP_TYPE_PNG),
                               wxS("Vytvoří parabolu zadanou ohniskem a vrcholem"), wxITEM_RADIO);

    //toolBar1->InsertSeparator(10);
//    toolBar1->AddTool(108, wxS("Guma"), wxBitmap(wxS("ikony/Guma.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Smaže vybrané objekty"), wxITEM_NORMAL);
//
//    toolBar1->AddTool(120, wxS("Změna vlastností objektu"), wxBitmap(wxS("ikony/Color.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Změní vlastnosti aktulně vybraným objektům"), wxITEM_NORMAL);
//
//    toolBar1->InsertSeparator(2);
//
//    toolBar1->AddTool(113, wxS("Bez přichytávání"), wxBitmap(wxS("ikony/BezPrichytavani.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Bez přichytávání"), wxITEM_RADIO);
//    toolBar1->AddTool(104, wxS("Přichytávání k mřížce"), wxBitmap(wxS("ikony/PrichytavaniKMrizce.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Přichytávání k mřížce"), wxITEM_RADIO);
//    toolBar1->AddTool(111, wxS("Přichytávání ke koncovým bodům"), wxBitmap(wxS("ikony/PrichytavaniKeKoncovymBodum.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Přichytávání ke koncovým bodům"), wxITEM_RADIO);
//    toolBar1->AddTool(112, wxS("Přichytávání k průsečíkům"), wxBitmap(wxS("ikony/PrichytavaniKPrusecikum.png"), wxBITMAP_TYPE_PNG),
//                               wxS("Přichytávání k průsečíkům"), wxITEM_RADIO);

    toolBar1->Realize();

    //toolBar2->Realize();
}

